dnl $Id$
dnl config.m4 for extension senna

dnl Comments in this file start with the string 'dnl'.
dnl Remove where necessary. This file will not work
dnl without editing.

dnl If your extension references something external, use with:

PHP_ARG_WITH(senna, for senna support,
Make sure that the comment is aligned:
[  --with-senna             Include senna support])

dnl Otherwise use enable:

dnl PHP_ARG_ENABLE(senna, whether to enable senna support,
dnl Make sure that the comment is aligned:
dnl [  --enable-senna           Enable senna support])

if test "$PHP_SENNA" != "no"; then
	PHP_EXPAND_PATH($SENNA_INCLUDE, SENNA_INCLUDE)

	AC_MSG_CHECKING([for senna-cfg])
	for i in $PHP_SENNA $PHP_SENNA/bin /usr/local/senna/bin /usr/local/bin /usr/bin ""; do
		if test -x $i/senna-cfg; then
			SENNA_CONFIG="$i/senna-cfg"
			break;
		fi
	done
	
	if test -n "$SENNA_CONFIG"; then
		AC_MSG_RESULT([$SENNA_CONFIG])
		SENNA_INCLUDE=`$SENNA_CONFIG --cflags`
		SENNA_LIBDIR=`$SENNA_CONFIG --libs`
		AC_DEFINE(HAVE_SENNA, 1, [Whether to have Senna])
	else
		AC_MSG_RESULT(not found)
		if test "$PHP_SENNA" = "yes"; then
			SENNA_SEARCH_PATHS="/usr /usr/local /usr/local/senna"
		else
			SENNA_SEARCH_PATHS=$PHP_SENNA
		fi
		
		for i in $SENNA_SEARCH_PATHS; do
			for j in include include/senna ""; do
				if test -r "$i/$j/senna.h"; then
					SENNA_INC_BASE=$i
					SENNA_INCLUDE=$i/$j
					AC_DEFINE(HAVE_SENNA_H, 1, [Whether to have senna.h])
				fi
			done
			
			for j in lib lib/senna ""; do
				if test -f "$i/$j/libsenna.so" || test -f "$i/$j/libsenna.a"; then 
					SENNA_LIBDIR=$i/$j
				fi
			done
		done
	fi
	
	if test -z "$SENNA_INCLUDE"; then
		AC_MSG_ERROR(Cannot find senna.h. Please specify correct Senna installation path)
	fi

	if test -z "$SENNA_LIBDIR"; then
		AC_MSG_ERROR(Cannot find libsenna.so. Please specify correct Senna installation path)
	fi

	if test -z "$SENNA_INCLUDE" -a -z "$SENNA_LIBDIR" ; then
		AC_MSG_ERROR([Unable to find libsenna anywhere under $withval])
	fi

	dnl old_LIBS=$LIBS
	dnl old_LDFLAGS=$LDFLAGS
	dnl LDFLAGS="$LDFLAGS -L$SENNA_LIBDIR"
	dnl AC_CHECK_LIB(senna, sen_init, AC_DEFINE(HAVE_SEN_INIT, 1, [Senna 0.1 or later]))
	dnl LIBS=$old_LIBS
	dnl LDFLAGS=$old_LDFLAGS

	PHP_CHECK_LIBRARY(senna, sen_init, [
		PHP_EVAL_INCLINE($SENNA_INCLUDE)
		PHP_EVAL_LIBLINE($SENNA_LIBDIR, SENNA_SHARED_LIBADD)
	], [
		AC_MSG_ERROR([senna lib not found. See config.log for more information.])
	], [$SENNA_LIBDIR])

	PHP_NEW_EXTENSION(senna, senna.c senna_index.c senna_records_subrecords.c senna_records_row.c senna_records.c senna_snippet.c, $ext_shared)
	PHP_SUBST(SENNA_SHARED_LIBADD)
	
	mv run-tests.php run-test.php.orig
	$SED -e "s/\$pass_options\s*=\s*'';/\$pass_options = ' -n';/g" run-test.php.orig > run-tests.php
	rm run-test.php.orig
fi
