#ifndef PHP_SENNA_IN_H
#define PHP_SENNA_IN_H

#include "php.h"

#define SPL_CE(class_name) spl_ce_ ## class_name

/* ¾μ¹Ի顼SPLƤRuntimeExceptionλҥ饹Ȥ */
extern zend_class_entry *SPL_CE(OutOfBoundsException);      /* Ȥϰϳ */
extern zend_class_entry *SPL_CE(UnexpectedValueException);  /* ȤѤǤʤ */

/*
 * å顼SPLƤ㳰Ȥ
 * php_error_docref()Fatal ErrorȯȡcatchǤʤƥȤˤ
 * ʤ٤㳰ꤲ
 */
extern zend_class_entry *SPL_CE(BadMethodCallException);    /* ƤǤϤʤǥ᥽åɤƤ */
extern zend_class_entry *SPL_CE(InvalidArgumentException);  /* ο䷿㤦 */

/*
 * ȯԻκ黻ҿ(ñ)ϡǥեȤ32Ȥ롣
 * Ludia, Tritonn, Google32äΤǤ򻲹ͤˤ
 */
#define PHP_SENNA_DEFAULT_MAX_N_EXPRS 32

/* 
  	Declare any global variables you may need between the BEGIN
	and END macros here:     
 */
ZEND_BEGIN_MODULE_GLOBALS(senna)
	char *api_version; /* Senna饤֥ΥС */
	sen_encoding default_encoding;
ZEND_END_MODULE_GLOBALS(senna)

/* In every utility function you add that needs to use variables 
   in php_senna_globals, call TSRMLS_FETCH(); after declaring other 
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as SENNA_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define SENNA_G(v) TSRMG(senna_globals_id, zend_senna_globals *, v)
#else
#define SENNA_G(v) (senna_globals.v)
#endif

ZEND_EXTERN_MODULE_GLOBALS(senna)

/* ʲޥ */
#define SENNA_CE(class_name)       ce_ ## class_name
#define SENNA_HANDLER(class_name)  handler_ ## class_name

#define REGISTER_SENNA_CLASS(name, funcs, ctor) { \
	zend_class_entry ce; \
	INIT_CLASS_ENTRY(ce, #name, funcs);  \
	SENNA_CE(name) = zend_register_internal_class(&ce TSRMLS_CC); \
	SENNA_CE(name)->create_object = ctor; \
	\
	memcpy(&SENNA_HANDLER(name), zend_get_std_object_handlers(), sizeof(zend_object_handlers)); \
}

#define REGISTER_SENNA_STRING_CONSTANT(class_name, const_name, value) \
	zend_declare_class_constant_string(SENNA_CE(class_name), const_name, sizeof(const_name) - 1, value TSRMLS_CC);
	
#define REGISTER_SENNA_LONG_CONSTANT(class_name, const_name, value) \
	zend_declare_class_constant_long(SENNA_CE(class_name), const_name, sizeof(const_name) - 1, (long) value TSRMLS_CC);

#define REGISTER_SENNA_LONG_CONSTANT_ENCODINGS(class_name) { \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_DEFAULT", sen_enc_default); \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_NONE",    sen_enc_none);    \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_EUC_JP",  sen_enc_euc_jp);  \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_UTF8",    sen_enc_utf8);    \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_SJIS",    sen_enc_sjis);    \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_LATIN1",  sen_enc_latin1);  \
	REGISTER_SENNA_LONG_CONSTANT(class_name, "ENC_KOI8R",   sen_enc_koi8r);   \
}

#endif  /* PHP_SENNA_IN_H */

