
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "zend_exceptions.h"
#include "zend_interfaces.h"

#include <senna.h>
#include "php_senna.h"
#include "php_senna_in.h"

#include "senna_records.h"
#include "senna_records_row.h"
#include "senna_records_subrecords.h"

/* SPLͭʤ顢Countable󥿡եȤ */
#ifdef PHP_SENNA_CAN_DEPENDS_ON_SPL
extern PHPAPI zend_class_entry *SPL_CE(Countable);
#endif

zend_object_handlers SENNA_HANDLER(Senna_Records_SubRecords);
PHPAPI zend_class_entry  *SENNA_CE(Senna_Records_SubRecords);


/* {{{ senna_records_subrecords_free() free for Senna_Records_Row object */
void senna_records_subrecords_free(void *object TSRMLS_DC) {
	senna_records_subrecords_object *senna_records_subrecords = (senna_records_subrecords_object *) object;
	
	if (senna_records_subrecords->zval_senna_records) {
		zval_ptr_dtor(&senna_records_subrecords->zval_senna_records);
	}
	
	zend_object_std_dtor(&senna_records_subrecords->std TSRMLS_CC);

	efree(object);
} /* }}} */

/* {{{ senna_records_subrecords_new() allocate for Senna_Records_SubRecords object */
static zend_object_value senna_records_subrecords_new(zend_class_entry *class_type TSRMLS_DC) {
	zend_object_value value;
	senna_records_subrecords_object *senna_records_subrecords;
	zval *tmp;
	
	senna_records_subrecords = ecalloc(1, sizeof(*senna_records_subrecords));

	value.handlers = &SENNA_HANDLER(Senna_Records_SubRecords);
	value.handle = zend_objects_store_put(senna_records_subrecords, (zend_objects_store_dtor_t) zend_objects_destroy_object, (zend_objects_free_object_storage_t) senna_records_subrecords_free, NULL TSRMLS_CC);
	
	zend_object_std_init(&senna_records_subrecords->std, class_type TSRMLS_CC);
	zend_hash_copy(senna_records_subrecords->std.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref, (void *) &tmp, sizeof(zval *));

	return value;
} /* }}} */

/* {{{ foreachIteratorؿ */

typedef struct _senna_records_subrecords_iterator {
	zend_object_iterator it;
	senna_records_subrecords_object *senna_records_subrecords;
	ulong index;
} senna_records_subrecords_iterator;

static void senna_records_subrecords_iterator_dtor(zend_object_iterator *it TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	if (I->it.data) {
		zval_ptr_dtor((zval **) &I->it.data);
	}
	efree(I);
}

static int senna_records_subrecords_iterator_valid(zend_object_iterator *it TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	return  (I->index < (ulong) I->senna_records_subrecords->n_subrecords) ? SUCCESS : FAILURE;
}

/* forward declaration */
senna_records_row_object *senna_records_subrecords_row_constructor(zval *target, zval *zval_subrecords, int index TSRMLS_DC);

static void senna_records_subrecords_iterator_current_data(zend_object_iterator *it, zval ***data TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	zval *current_row;
	
	if (0 == I->senna_records_subrecords->n_subrecords) {
		*data = NULL;
		return;
	}
	
	MAKE_STD_ZVAL(current_row);
	object_init_ex(current_row, SENNA_CE(Senna_Records_Row));
	senna_records_subrecords_row_constructor(current_row, (zval *) I->it.data, (int) I->index);

	*data = &current_row;
}

static int senna_records_subrecords_iterator_current_key(zend_object_iterator *it, char **str_key, uint *str_key_len, ulong *int_key TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	if (0 == I->senna_records_subrecords->n_subrecords) {
		return HASH_KEY_NON_EXISTANT;
	}
	
	*int_key = I->index;
	return HASH_KEY_IS_LONG;
}

static void senna_records_subrecords_iterator_move_forwards(zend_object_iterator *it TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	I->index++;
}

static void senna_records_subrecords_iterator_rewind(zend_object_iterator *it TSRMLS_DC) {
	senna_records_subrecords_iterator *I = (senna_records_subrecords_iterator *) it;
	I->index = 0;
}


static zend_object_iterator_funcs senna_records_subrecords_iterator_funcs = {
	senna_records_subrecords_iterator_dtor,
	senna_records_subrecords_iterator_valid,
	senna_records_subrecords_iterator_current_data,
	senna_records_subrecords_iterator_current_key,
	senna_records_subrecords_iterator_move_forwards,
	senna_records_subrecords_iterator_rewind
};

zend_object_iterator *senna_records_subrecords_get_iterator(zend_class_entry *ce, zval *object, int by_ref TSRMLS_DC) {
	senna_records_subrecords_iterator *I;
	
	if (by_ref) {
		zend_error(E_ERROR, "An iterator cannot be used with foreach by reference");
	}

	I = ecalloc(1, sizeof(*I));
	I->senna_records_subrecords = (senna_records_subrecords_object *) zend_object_store_get_object(object TSRMLS_CC);
	I->index = 0;
	I->it.funcs = &senna_records_subrecords_iterator_funcs;
	I->it.data = (void *) object;
	zval_add_ref(&object);
	
	return (zend_object_iterator *) I;
}

/* }}} */

/* ޤZendƥ󥷥Ȥɬפˤʤؿ */
/* إѡؿ */

/* {{{ senna_records_subrecords_constructor() create a instance for Senna_Records_SubRecords object
 * ƥ󥷥Senna_Records_SubRecords󥹥ȥ饯
 * Senna_Records_Row饹getSubRecords()Ƥ֡
 * 1˻ꤷzval*ѿSenna_Records_SubRecords֥ȤȤƽ롣
 */
senna_records_subrecords_object *senna_records_subrecords_constructor(zval *target, zval *zval_senna_records_row TSRMLS_DC) {
	senna_records_subrecords_object *this;
	senna_records_row_object *senna_records_row;
	
	this = (senna_records_subrecords_object *) zend_object_store_get_object(target TSRMLS_CC);
	senna_records_row = (senna_records_row_object *) zend_object_store_get_object(zval_senna_records_row TSRMLS_CC);
	
	this->row = senna_records_row->row;
	this->n_subrecords = senna_records_row->n_subrecords;
	
	/* Records_SubRecords󥹥󥹤Records󥹥󥹤򻲾Ȥ롣 */
	this->zval_senna_records = senna_records_row->zval_senna_records;
	zval_add_ref(&senna_records_row->zval_senna_records);
	
	return this;
} /* }}} */

/* {{{ Senna_Records_SubRecordsݻƥ֥쥳ɤ⡢Senna_Records_Row֥ȤˤʤäƤ */
senna_records_row_object *senna_records_subrecords_row_constructor(zval *target, zval *zval_subrecords, int index TSRMLS_DC) {
	senna_records_subrecords_object *this;
	senna_records_row_object *row;
	senna_records_object *senna_records;
	sen_rc result;
	char keybuf[SEN_SYM_MAX_KEY_SIZE];

	this = (senna_records_subrecords_object *) zend_object_store_get_object(zval_subrecords TSRMLS_CC);
	
	if ((index < 0) || (this->n_subrecords <= (unsigned int) index)) {
		if (this->n_subrecords) {
			zend_throw_exception_ex(SPL_CE(OutOfBoundsException), 0 TSRMLS_CC, "Argument #1(offset index) out of bounds. This object has 0..%d offsets, %d given", this->n_subrecords - 1, index);
		} else {
			/* ۥȤNullPointerExceptionɤΤ⡩ */
			zend_throw_exception_ex(SPL_CE(OutOfBoundsException), 0 TSRMLS_CC, "Argument #1(offset index) out of bounds. This object has no sub record");
		}
		return NULL;
	}
	
	row = (senna_records_row_object *) zend_object_store_get_object(target TSRMLS_CC);
	row->row = this->row;
	row->n_subrecords = 0; /* ֥֥쥳ɤγǰ̵褦ʤΤ0 */
	row->zval_senna_records = this->zval_senna_records;
	zval_add_ref(&this->zval_senna_records);
	
	senna_records = (senna_records_object *) zend_object_store_get_object(row->zval_senna_records TSRMLS_CC);
	result = sen_record_subrec_info(
		senna_records->records,
		row->row,
		index,
		keybuf,
		SEN_SYM_MAX_KEY_SIZE,
		&row->keysize, /* strlen(key) + 1ˤʤ롣ĤޤꡢkeyNULLüʸξϡNULL1byteޤ᤿Ĺ */
		&row->section,
		&row->position,
		&row->score
	);
	
	if (sen_success != result) {
		zend_throw_exception_ex(SENNA_CE(SennaException), result TSRMLS_CC, "sen_record_subrec_info() returned error code %d", result);
		return NULL;
	}

	/*
	 * keyNULLüɤˤ餺NULLüʸˤʤ롣
	 * NULLüä硢1NULLɲä롣
	 */
	row->key = estrndup(keybuf, row->keysize);
	
	return row;
} /* }}} */

/* Senna_Records_SubRecords饹Υ᥽å */

/* {{{ proto private void Senna_Records_SubRecords::__construct()
 * Senna_Records_SubRecords֥ȤϡPHP¦ǤϼưǤʤ
 * Senna_Records_Row饹⤫Τ롣
 */
PHP_METHOD(Senna_Records_SubRecords, __construct) {
	zend_throw_exception_ex(SPL_CE(BadMethodCallException), 0 TSRMLS_CC, "You cannot create an instance of Senna_Records_SubRecords manually");
	/* php_error_docref(NULL TSRMLS_CC, E_ERROR, "You should not create a Senna_Records_SubRecords instance manually"); */
}
/* }}} */

/* {{{ proto int Senna_Records_SubRecords::count()
   Returns the number of sub records in a buffered record set. */
PHP_METHOD(Senna_Records_SubRecords, count) {
	senna_records_subrecords_object *senna_records_subrecords = (senna_records_subrecords_object *) zend_object_store_get_object(getThis() TSRMLS_CC);
	RETURN_LONG((long) senna_records_subrecords->n_subrecords);
}
/* }}} */

/* {{{ proto array Senna_Records_SubRecords::slice(int offset, int count)
 * Ex. $row = $subrecords[12];
 */
PHP_METHOD(Senna_Records_SubRecords, slice) {
	long offset;
	long count;
	
	php_set_error_handling(EH_THROW, SPL_CE(InvalidArgumentException) TSRMLS_CC);

	if (FAILURE == zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "ll", &offset, &count)) {
		php_std_error_handling();
		return;
	}

	php_std_error_handling();
	
	if (offset < 0) {
		zend_throw_exception_ex(SPL_CE(UnexpectedValueException), 0 TSRMLS_CC, "Argument #1(offset) must be greater than or equal to 0");
		return;
	}
	
	if (count < 1) {
		zend_throw_exception_ex(SPL_CE(UnexpectedValueException), 0 TSRMLS_CC, "Argument #2(count) must be greater than or equal to 1");
		return;
	}
	
	array_init(return_value);
	{
		senna_records_subrecords_object *this = (senna_records_subrecords_object *) zend_object_store_get_object(getThis() TSRMLS_CC);
		zval *zval_row;
		int i;
		int max = this->n_subrecords;
		int limit = (offset + count < max) ? offset + count : max;
		
		for (i = offset; i < limit; i++) {
			/* offsetܤlimitĤΥ֥쥳ɤ */
			MAKE_STD_ZVAL(zval_row);
			object_init_ex(zval_row, SENNA_CE(Senna_Records_Row));
			senna_records_subrecords_row_constructor(zval_row, getThis(), i);

			add_next_index_zval(return_value, zval_row);
		}
	}
} /* }}} */

/* {{{ proto bool Senna_Records_SubRecords::offsetGet(int index)
 * Ex. $row = $subrecords[12];
 */
PHP_METHOD(Senna_Records_SubRecords, offsetGet) {
	long index;

	senna_records_subrecords_object *this;

	php_set_error_handling(EH_THROW, SPL_CE(InvalidArgumentException) TSRMLS_CC);

	if (FAILURE == zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &index)) {
		php_std_error_handling();
		return;
	}

	php_std_error_handling();
	
	/* ͤΥåsenna_records_subrecords_row_constructor()Ǥ */
	
	object_init_ex(return_value, SENNA_CE(Senna_Records_Row));
	senna_records_subrecords_row_constructor(return_value, getThis(), (int) index);
} /* }}} */

/* {{{ proto bool Senna_Records_SubRecords::offsetExists(int index)
 * Ex. isset($row[32]);
 */
PHP_METHOD(Senna_Records_SubRecords, offsetExists) {
	long index;
	
	senna_records_subrecords_object *this;
	
	php_set_error_handling(EH_THROW, SPL_CE(InvalidArgumentException) TSRMLS_CC);

	if (FAILURE == zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "l", &index)) {
		php_std_error_handling();
		return;
	}

	php_std_error_handling();

	this = (senna_records_subrecords_object *) zend_object_store_get_object(getThis() TSRMLS_CC);
	
	if ((index < 0) || (this->n_subrecords <= (unsigned int) index)) {
		RETURN_FALSE;
	} else {
		RETURN_TRUE;
	}
} /* }}} */

PHP_METHOD(Senna_Records_SubRecords, offsetSet) {
	/* Senna_Records_SubRecords֥ȤѹԲĤʤΤǡsetter̤ */
	zend_throw_exception_ex(SPL_CE(BadMethodCallException), 0 TSRMLS_CC, "Senna_Records_SubRecords properties are read only. This method is not implemented");
	/*
	php_error_docref(NULL TSRMLS_CC, E_ERROR,
			"Senna_Records_SubRecords object is read only. Senna_Records_SubRecords::offsetSet() is not implemented");
	*/
}

PHP_METHOD(Senna_Records_SubRecords, offsetUnset) {
	/* Senna_Records_SubRecords֥ȤѹԲĤʤΤǡoffsetUnset()᥽åɤ̤ */
	zend_throw_exception_ex(SPL_CE(BadMethodCallException), 0 TSRMLS_CC, "Senna_Records_SubRecords properties are read only. This method is not implemented");
	/*
	php_error_docref(NULL TSRMLS_CC, E_ERROR,
			"Senna_Records_SubRecords object is read only. Senna_Records_SubRecords::offsetUnset() is not implemented");
	*/
}

/* implements ArrayAccessΤˡꤹ */
static ZEND_BEGIN_ARG_INFO_EX(arginfo_offsetGet, 0, 0, 1)
	ZEND_ARG_INFO(0, index)
ZEND_END_ARG_INFO()

static ZEND_BEGIN_ARG_INFO_EX(arginfo_offsetSet, 0, 0, 2)
	ZEND_ARG_INFO(0, index)
	ZEND_ARG_INFO(0, newval)
ZEND_END_ARG_INFO()

zend_function_entry senna_records_subrecords_functions[] = {
	PHP_ME(Senna_Records_SubRecords, __construct,  NULL, ZEND_ACC_PRIVATE | ZEND_ACC_CTOR)
	
	/* implements Countable */
	PHP_ME(Senna_Records_SubRecords, count, NULL, ZEND_ACC_PUBLIC)
	
	PHP_ME(Senna_Records_SubRecords, slice, NULL, ZEND_ACC_PUBLIC)
	PHP_MALIAS(Senna_Records_SubRecords, get, offsetGet, arginfo_offsetGet, ZEND_ACC_PUBLIC)
	
	/* implements ArrayAccess */
	PHP_ME(Senna_Records_SubRecords, offsetGet,    arginfo_offsetGet, ZEND_ACC_PUBLIC)
	PHP_ME(Senna_Records_SubRecords, offsetSet,    arginfo_offsetSet, ZEND_ACC_PUBLIC)
	PHP_ME(Senna_Records_SubRecords, offsetUnset,  arginfo_offsetGet, ZEND_ACC_PUBLIC)
	PHP_ME(Senna_Records_SubRecords, offsetExists, arginfo_offsetGet, ZEND_ACC_PUBLIC)
	{NULL, NULL, NULL}
};


PHP_MINIT_FUNCTION(senna_records_subrecords) {
	REGISTER_SENNA_CLASS(Senna_Records_SubRecords, senna_records_subrecords_functions, senna_records_subrecords_new);
	SENNA_CE(Senna_Records_SubRecords)->get_iterator = senna_records_subrecords_get_iterator;
	
#ifdef PHP_SENNA_CAN_DEPENDS_ON_SPL
	zend_class_implements(SENNA_CE(Senna_Records_SubRecords) TSRMLS_CC, 3, zend_ce_traversable, zend_ce_arrayaccess, SPL_CE(Countable));
#else
	zend_class_implements(SENNA_CE(Senna_Records_SubRecords) TSRMLS_CC, 2, zend_ce_traversable, zend_ce_arrayaccess);
#endif
	
	return SUCCESS;
}


/* The previous line is meant for vim and emacs, so it can correctly fold and 
   unfold functions in source code. See the corresponding marks just before 
   function definition, where the functions purpose is also documented. Please 
   follow this convention for the convenience of others editing your code.
*/


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
