--TEST--
Senna_Index - getter methods test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testGetInfo_FromCreatedIndex();
testGetInfo_FromOpenedIndex();

// VK쐬CfbNX̏擾
function testGetInfo_FromCreatedIndex() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	$KEY_SIZE = 12;
	$FLAGS = Senna_Index::NORMALIZE | Senna_Index::SPLIT_ALPHA;
	$INIT_SEGMENTS = 128;
	$ENCODING = Senna::ENC_SJIS;
	
	// RXgN^ŃCX^Xꍇ
	$index = new Senna_Index($path, $KEY_SIZE, $FLAGS, $INIT_SEGMENTS, $ENCODING);
	if ($index->getKeySize() != $KEY_SIZE) {
		echo "failure: unexpected key_size.\n";
	}
	if ($index->getFlags() != $FLAGS) {
		echo "failure: unexpected flags.\n";
	}
	if ($index->getInitialSegments() != $INIT_SEGMENTS) {
		echo "failure: unexpected initial_n_segments.\n";
	}
	if ($index->getEncoding() != $ENCODING) {
		echo "failure: unexpected encoding.\n";
	}
	if ($index->getPath() != $path) {
		echo "failure: unexpected path.\n";
	}
	Senna_Index::remove($path);

	// create()ŃCX^Xꍇ
	$index = Senna_Index::create($path, $KEY_SIZE, $FLAGS, $INIT_SEGMENTS, $ENCODING);
	if ($index->getKeySize() != $KEY_SIZE) {
		echo "failure: unexpected key_size.\n";
	}
	if ($index->getFlags() != $FLAGS) {
		echo "failure: unexpected flags.\n";
	}
	if ($index->getInitialSegments() != $INIT_SEGMENTS) {
		echo "failure: unexpected initial_n_segments.\n";
	}
	if ($index->getEncoding() != $ENCODING) {
		echo "failure: unexpected encoding.\n";
	}
	if ($index->getPath() != $path) {
		echo "failure: unexpected path.\n";
	}
	Senna_Index::remove($path);
	
	unlink($path);
}

// ̃CfbNX̏擾
function testGetInfo_FromOpenedIndex() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	$KEY_SIZE = 12;
	$FLAGS = Senna_Index::NORMALIZE | Senna_Index::SPLIT_ALPHA;
	$INIT_SEGMENTS = 128;
	$ENCODING = Senna::ENC_SJIS;
	
	// eXgp̃CfbNXB
	Senna_Index::create($path, $KEY_SIZE, $FLAGS, $INIT_SEGMENTS, $ENCODING);
	
	// RXgN^ŊJꍇAɉ^Ă
	$index = new Senna_Index($path, 133, 0, 123, 0);
	if ($index->getKeySize() != $KEY_SIZE) {
		echo "failure: unexpected key_size.\n";
	}
	if ($index->getFlags() != $FLAGS) {
		echo "failure: unexpected flags.\n";
	}
	if ($index->getInitialSegments() != $INIT_SEGMENTS) {
		echo "failure: unexpected initial_n_segments.\n";
	}
	if ($index->getEncoding() != $ENCODING) {
		echo "failure: unexpected encoding.\n";
	}
	if ($index->getPath() != $path) {
		echo "failure: unexpected path.\n";
	}
	unset($index);

	// open()\bhŊJꍇ
	$index = Senna_Index::open($path);
	if ($index->getKeySize() != $KEY_SIZE) {
		echo "failure: unexpected key_size.\n";
	}
	if ($index->getFlags() != $FLAGS) {
		echo "failure: unexpected flags.\n";
	}
	if ($index->getInitialSegments() != $INIT_SEGMENTS) {
		echo "failure: unexpected initial_n_segments.\n";
	}
	if ($index->getEncoding() != $ENCODING) {
		echo "failure: unexpected encoding.\n";
	}
	if ($index->getPath() != $path) {
		echo "failure: unexpected path.\n";
	}
	unset($index);
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===