--TEST--
Senna_Index::__construct() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testConstructor_WithNoArguments();
testConstructor_WithEmptyPath();
testConstructor_WithNegativeKeySize();
testConstructor_WithOverMaxKeySize();
testConstructor_WithNegativeInitialSegments();
testConstructor_WithUnsupportedEncoding();

// 1ĤʤInvalidArgumentExceptionꤲ
function testConstructor_WithNoArguments() {
	echo "### Constructor expects at least 1 parameter\n";
	try {
		$index = new Senna_Index();
		echo "The expected exception has not been thrown.\n";
	/*
	// SPLʤPHPưƤ硢InvalidArgumentException饹ʤΤǥƥȼΤ¹ԤǤʤʤ
	// ƥȥץȤǤϡSennaExceptionʳException饹ȤƥågetMessage()ǥåĴ٤뤳Ȥˤ롣
	} catch (InvalidArgumentException $expected) {
	*/
	} catch (Exception $expected) {
		echo "no parameter\n";  // PHPλͤǥ顼å㤦⤷ʤΤǡgetMessage()ǤϤʤ٥
	}
}

// 1ʸξUnexpectedValueExceptionꤲ
function testConstructor_WithEmptyPath() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	
	echo "### path is empty\n";
	try {
		$index = new Senna_Index('');
		echo "The expected exception has not been thrown.\n";
		Senna_Index::remove($path);
	} catch (Exception $expected) {
		echo $expected->getMessage(), "\n";
	}

	unlink($path);
}

// 20̤ʤUnexpectedValueExceptionꤲ
function testConstructor_WithNegativeKeySize() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### key_size is negative\n";
	try {
		$index = new Senna_Index($path, -1);
		echo "The expected exception has not been thrown.\n";
		Senna_Index::remove($path);
	} catch (Exception $expected) {
		echo $expected->getMessage(), "\n";
	}

	unlink($path);
}

// 2Senna_Index::MAX_KEY_SIZEĶʤUnexpectedValueExceptionꤲ
function testConstructor_WithOverMaxKeySize() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### key_size is greater than Senna_Index::MAX_KEY_SIZE\n";
	try {
		$index = new Senna_Index($path, Senna_Index::MAX_KEY_SIZE + 1);
		echo "The expected exception has not been thrown.\n";
		Senna_Index::remove($path);
	} catch (Exception $expected) {
		echo $expected->getMessage(), "\n";
	}

	unlink($path);
}

// 40̤ͤʤUnexpectedValueExceptionꤲ
function testConstructor_WithNegativeInitialSegments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### initial_n_segments is negative\n";
	try {
		$index = new Senna_Index($path, Senna_Index::VARIABLE_KEY_SIZE, NULL, -1);
		echo "The expected exception has not been thrown.\n";
		Senna_Index::remove($path);
	} catch (Exception $expected) {
		echo $expected->getMessage(), "\n";
	}

	unlink($path);
}

// 5бƤʤ󥳡ǥ󥰤ʤUnexpectedValueExceptionꤲ
function testConstructor_WithUnsupportedEncoding() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### encoding is an unsupported type\n";
	try {
		$index = new Senna_Index($path, Senna_Index::VARIABLE_KEY_SIZE, NULL, Senna_Index::DEFAULT_INITIAL_N_SEGMENTS, -1);
		echo "The expected exception has not been thrown.\n";
		Senna_Index::remove($path);
	} catch (Exception $expected) {
		echo $expected->getMessage(), "\n";
	}

	unlink($path);
}
?>
--EXPECTF--
### Constructor expects at least 1 parameter
no parameter
### path is empty
Argument #1(path) cannot be empty
### key_size is negative
Argument #2(key size) must be 0 or 1..%d (0 means key size is variable length), -1 given
### key_size is greater than Senna_Index::MAX_KEY_SIZE
Argument #2(key size) must be 0 or 1..%d (0 means key size is variable length), %d given
### initial_n_segments is negative
Argument #4(initial segments) must be greater than or equal to 0, -1 given
### encoding is an unsupported type
Argument #5(encoding) must be one of Senna::ENC_DEFAULT, Senna::ENC_UTF8, Senna::ENC_EUC_JP, Senna::ENC_SJIS, Senna::ENC_LATIN1, Senna::ENC_KOI8R or Senna::ENC_NONE
