--TEST--
Senna_Index::__construct() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testConstructor_WithValidArguments();
testConstructor_CreatesNewIndexFile();
testConstructor_OpensExistingIndexFile();

// ưάͤꤷƥ󥹥󥹲Ǥ뤳Ȥǧ롣
function testConstructor_WithValidArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### Arg2\n";
	try {
		$index = new Senna_Index($path, 0);
		Senna_Index::remove($path);
		echo "arg2 = 0\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	try {
		$index = new Senna_Index($path, Senna_Index::MAX_KEY_SIZE);
		Senna_Index::remove($path);
		echo "arg2 = Senna_Index::MAX_KEY_SIZE\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	echo "### Arg3\n";
	$arg3List = array(0, NULL,
			Senna_Index::NORMALIZE, Senna_Index::SPLIT_ALPHA, Senna_Index::SPLIT_DIGIT,
					Senna_Index::SPLIT_SYMBOL, Senna_Index::NGRAM, Senna_Index::DELIMITED,
							Senna_Index::NORMALIZE | Senna_Index::NGRAM);
	foreach ($arg3List as $item) {
		try {
			$index = new Senna_Index($path, Senna_Index::VARIABLE_KEY_SIZE, $item);
			Senna_Index::remove($path);
		} catch (Exception $unexpected) {
			echo $unexpected->getMessage(), "\n";
		}
		
	}

	echo "### Arg4\n";
	try {
		$index = new Senna_Index($path, Senna_Index::VARIABLE_KEY_SIZE, 0, 0);
		Senna_Index::remove($path);
		echo "arg4 = 0\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	try {
		$index = new Senna_Index($path, Senna_Index::VARIABLE_KEY_SIZE, 0, 1024);
		Senna_Index::remove($path);
		echo "arg4 = 1024\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	unlink($path);
}

// ǥåե뤬¸ߤʤϡcreate()Ʊư򤹤
function testConstructor_CreatesNewIndexFile() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	if (file_exists("{$path}.SEN")) {
		echo "failure: .SEN file already exists\n";
	}
	
	// ǥåե뤬
	$index = new Senna_Index($path);
	if (file_exists("{$path}.SEN")) {
		echo ".SEN file is created\n";
	}
	Senna_Index::remove($path);
	
	unlink($path);
}

// ǥåե뤬¸ߤϡopen()Ʊư򤹤
function testConstructor_OpensExistingIndexFile() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	
	// ƥѥǥå롣
	$index = new Senna_Index($path);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	unset($index);
	
	// ¸Υǥå򳫤ǤϤʤñʤopenǤСΤǸ̤2ˤʤ롣
	$another = new Senna_Index($path);
	if (2 == $another->query('test')->count()) {
		// ǤϤʤñʤopenǤС̤2ˤʤ롣
		echo ".SEN file is opened\n";
	}
	Senna_Index::remove($path);

	unlink($path);
}
?>
--EXPECT--
### Arg2
arg2 = 0
arg2 = Senna_Index::MAX_KEY_SIZE
### Arg3
### Arg4
arg4 = 0
arg4 = 1024
.SEN file is created
.SEN file is opened
