--TEST--
Senna_Index::create() - permission test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testCreate_DirectoryHasNoWritePermission();

testCreate_IndexFileHasNoWritePermission();
testCreate_IndexFileHasNoReadPermission();

// 񤭹߸¤̵ǥ쥯ȥ˥ǥåեϺʤΤǡSennaExceptionꤲ
function testCreate_DirectoryHasNoWritePermission() {
	$path = sys_get_temp_dir() . '/php_senna-test' . getmypid();
	mkdir($path , 0400) or die('mkdir() failed.');
	
	echo "### directory: no write permission\n";
	try {
		$index = Senna_Index::create($path .'/test_index');
		echo "The expected exception has not been thrown.\n";
	} catch (SennaException $expected) {
		echo $expected->getMessage(), "\n";
	}
	
	chmod($path, 0755);
	rmdir($path);
}

// 񤭹߸¤̵ǥåեϾ񤭤ǤʤΤǡSennaExceptionꤲ
function testCreate_IndexFileHasNoWritePermission() {
	$path = sys_get_temp_dir() . '/php_senna-test' . getmypid();
	mkdir($path , 0755) or die('mkdir() failed.');
	$filename = $path .'/test_index';
	
	// ǥåե򿷵񤭹ߥѡߥåȤƤߤƥƥȤ
	$index = Senna_Index::create($filename);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	chmod("{$filename}.SEN", 0444);
	unset($index);

	echo "### index file: no write permission\n";
	try {
		$index = Senna_Index::create($filename);
		echo "The expected exception has not been thrown.\n";
	} catch (SennaException $expected) {
		echo $expected->getMessage(), "\n";
	}
	
	chmod("{$filename}.SEN", 0755);

	// 㳰ȯпƤʤΤǥǥåȤ϶ˤʤäƤʤ
	$index = Senna_Index::open($filename);
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	Senna_Index::remove($filename);
	
	rmdir($path);
}

// ɤ߹߸¤̵ǥåեtruncateǤƤⳫʤΤǡSennaExceptionꤲ
function testCreate_IndexFileHasNoReadPermission() {
	$path = sys_get_temp_dir() . '/php_senna-test' . getmypid();
	mkdir($path , 0755) or die('mkdir() failed.');
	$filename = $path .'/test_index';
	
	// ǥåե򿷵ɤ߹ߥѡߥåȤ
	$index = Senna_Index::create($filename);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	chmod("{$filename}.SEN", 0333);

	echo "### index file: no read permission\n";
	try {
		$index = Senna_Index::create($filename);
		echo "The expected exception has not been thrown.\n";
	} catch (SennaException $expected) {
		echo $expected->getMessage(), "\n";
	}
	
	chmod("{$filename}.SEN", 0755);

	// 㳰ȯпƤʤΤǡǥåȤƤޤȤʤ
	$index = Senna_Index::open($filename);
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	Senna_Index::remove($filename);
	
	rmdir($path);
}
?>
--EXPECTF--
### directory: no write permission
failed to create an index file(%s): Permission denied or no such directory
### index file: no write permission
failed to create an index file(%s): Permission denied or no such directory
### index file: no read permission
failed to create an index file(%s): Permission denied or no such directory
