--TEST--
Senna_Index::create() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testCreate_WithValidArguments();
testCreate_CreatesNewIndexFile();
testCreate_OverwriteExistingIndexFile();

// ưάͤꤷƥ󥹥󥹲Ǥ뤳Ȥǧ롣
function testCreate_WithValidArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	echo "### Arg2\n";
	try {
		$index = Senna_Index::create($path, 0);
		Senna_Index::remove($path);
		echo "arg2 = 0\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	try {
		$index = Senna_Index::create($path, Senna_Index::MAX_KEY_SIZE);
		Senna_Index::remove($path);
		echo "arg2 = Senna_Index::MAX_KEY_SIZE\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	echo "### Arg3\n";
	$arg3List = array(0, NULL,
			Senna_Index::NORMALIZE, Senna_Index::SPLIT_ALPHA, Senna_Index::SPLIT_DIGIT,
					Senna_Index::SPLIT_SYMBOL, Senna_Index::NGRAM, Senna_Index::DELIMITED,
							Senna_Index::NORMALIZE | Senna_Index::NGRAM);
	foreach ($arg3List as $item) {
		try {
			$index = Senna_Index::create($path, Senna_Index::VARIABLE_KEY_SIZE, $item);
			Senna_Index::remove($path);
		} catch (Exception $unexpected) {
			echo $unexpected->getMessage(), "\n";
		}
		
	}

	echo "### Arg4\n";
	try {
		$index = Senna_Index::create($path, Senna_Index::VARIABLE_KEY_SIZE, 0, 0);
		Senna_Index::remove($path);
		echo "arg4 = 0\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	try {
		$index = Senna_Index::create($path, Senna_Index::VARIABLE_KEY_SIZE, 0, 1024);
		Senna_Index::remove($path);
		echo "arg4 = 1024\n";
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}

	unlink($path);
}

// ǥåե뤬¸ߤʤϡǥåե򿷵
function testCreate_CreatesNewIndexFile() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	if (file_exists("{$path}.SEN")) {
		echo "failure: .SEN file already exists\n";
	}
	
	// ǥåե뤬
	$index = Senna_Index::create($path);
	if (file_exists("{$path}.SEN")) {
		echo ".SEN file is created\n";
	}
	Senna_Index::remove($path);
	unlink($path);
}

// ǥåե뤬¸ߤϡΥǥåȤƾ񤭤
function testCreate_OverwriteExistingIndexFile() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	
	// ƥѥǥå롣
	$index = Senna_Index::create($path);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	unset($index);
	
	// ǥåե
	$another = Senna_Index::create($path);
	
	// ΥǥåեˤʤäƤϤʤΤǡ쥳ɤ1Ǥʤ
	if (0 == $another->query('test')->count()) {
		echo "New .SEN file is created\n";
	}
	Senna_Index::remove($path);

	unlink($path);
}
?>
--EXPECT--
### Arg2
arg2 = 0
arg2 = Senna_Index::MAX_KEY_SIZE
### Arg3
### Arg4
arg4 = 0
arg4 = 1024
.SEN file is created
New .SEN file is created
