--TEST--
Senna_Index::open() - permission test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testOpen_IndexFileHasNoWritePermission();
testOpen_IndexFileHasNoReadPermission();

// ǥåե˽񤭹߸¤̵СSennaExceptionꤲ
function testOpen_IndexFileHasNoWritePermission() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	
	// ǥåե򿷵񤭹ߥѡߥåȤƤߤƥƥȤ
	$index = Senna_Index::create($path);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	chmod("{$path}.SEN", 0444);
	unset($index);

	echo "### index file: no write permission\n";
	try {
		$index = Senna_Index::open($path);
		echo "The expected exception has not been thrown.\n";
	} catch (SennaException $expected) {
		echo $expected->getMessage(), "\n";
	}
	
	chmod("{$path}.SEN", 0755);

	Senna_Index::remove($path);
	unlink($path);
}

// ǥåեɤ߹߸¤̵СSennaExceptionꤲ
function testOpen_IndexFileHasNoReadPermission() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	
	// ǥåե򿷵ɤ߹ߥѡߥåȤƤߤƥƥȤ
	$index = Senna_Index::create($path);
	$index->upd('key1', NULL, 'This is a test document.');
	$index->upd('key2', NULL, 'This is an another test document.');
	$index->upd('key3', NULL, 'I am a boy. I am a girl.');
	if (2 != $index->query('test')->count()) {
		echo "The expected records has not been retrieved.\n";
	}
	chmod("{$path}.SEN", 0444);
	unset($index);

	echo "### index file: no read permission\n";
	try {
		$index = Senna_Index::open($path);
		echo "The expected exception has not been thrown.\n";
	} catch (SennaException $expected) {
		echo $expected->getMessage(), "\n";
	}
	
	chmod("{$path}.SEN", 0755);

	Senna_Index::remove($path);
	unlink($path);
}
?>
--EXPECTF--
### index file: no write permission
failed to open an index file(%s): Permission denied or no such file or directory
### index file: no read permission
failed to open an index file(%s): Permission denied or no such file or directory
