--TEST--
Senna_Index::query() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testQuery_WithNoArguments();
testQuery_WithEmptyQuery();
testQuery_WithNonPositiveNumber();

// 1ĤʤInvalidArgumentExceptionꤲ
function testQuery_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->query();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testQuery_WithEmptyQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->query('');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->query(NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(ɡ黻ҸĿξ¿)0ʲξUnexpectedValueExceptionꤲ
function testQuery_WithNonPositiveNumber() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->query('test', 0);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->query('test', -1);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records = $index->query('test', -200);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

?>
===DONE===
--EXPECT--
===DONE===
