--TEST--
Senna_Index::remove() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testRemove_WithNoArgument();
testRemove_WithEmptyPath();

// Senna-1.0.9ޤǤsen_index_remove()Ƥ⼺ԤƤ㳰֤ХΤǥƥȤʤ
if (version_compare("1.1.0", Senna::API_VERSION, "<=")) {
	testRemove_AttemptToRemoveNonExistentIndexFile();
	testRemove_AttemptToRemoveIndexFileInNonWritePermissionDirectory();
}

function testRemove_WithNoArgument() {
	try {
		$index = Senna_Index::remove();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
}

// 1ξUnexpectedValueExceptionꤲ
function testRemove_WithEmptyPath() {
	try {
		Senna_Index::remove('');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
}

// ¸ߤʤեäȤȡFileOperationError֤
function testRemove_AttemptToRemoveNonExistentIndexFile() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	// $path.SENե¸ߤʤϤ褦ȤȼԤ롣
	try {
		Senna_Index::remove($path);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (SennaException $expected) {
	}

	unlink($path);
}

// 񤭹߸¤ʤǥ쥯ȥΥեϾäʤΤǡFileOperationError֤
function testRemove_AttemptToRemoveIndexFileInNonWritePermissionDirectory() {
	$path = sys_get_temp_dir() . '/php_senna-test' . getmypid();
	mkdir($path, 0755) or die('mkdir() failed in ' . __FUNCTION__);
	$filename = $path . '/test_index';
	
	Senna_Index::create($filename);
	chmod($path, 0400);  // ǥ쥯ȥν񤭹߸¤Ȥ

	// ¤ʤΤǺǤʤϤԤ롣
	try {
		Senna_Index::remove($filename);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (SennaException $expected) {
	}

	chmod($path, 0755);
	Senna_Index::remove($filename);
	
	rmdir($path);
}
?>
===DONE===
--EXPECTF--
===DONE===
