--TEST--
Senna_Index::upd() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testUpd_WithNoArguments();
testUpd_WithNonThreeArguments();

testUpd_WithEmptyKey();
//testUpd_WithEmptyOldValueAndEmptyNewValue();

// 1ĤʤInvalidArgumentExceptionꤲ
function testUpd_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->upd();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 3ĤǤʤInvalidArgumentExceptionꤲ
function testUpd_WithNonThreeArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->upd('key');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd('key', 'old');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd('key', 'old', 'new', 'unknown');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testUpd_WithEmptyKey() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->upd('', NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd(NULL, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 23(old_valuenew_value)˶ξUnexpectedValueExceptionꤲ
function testUpd_WithEmptyOldValueAndEmptyNewValue() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->upd('test', '', '');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd('test', NULL, NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd('test', '', NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->upd('test', NULL, '');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===
