--TEST--
Senna_Index::update() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testUpdate_WithNoArguments();
testUpdate_WithNonFourArguments();

testUpdate_WithEmptyKey();
testUpdate_WithNonPositiveSectionNumber();
//testUpdate_WithEmptyOldValueAndEmptyNewValue();

// 1ĤʤInvalidArgumentExceptionꤲ
function testUpdate_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->update();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 3ĤǤʤInvalidArgumentExceptionꤲ
function testUpdate_WithNonFourArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->update('key');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('key', 1);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('key', 1, 'old');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('key', 1, 'old', 'new', 'unknown');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testUpdate_WithEmptyKey() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->update('', 1, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update(NULL, 1, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(ֹ)0ʲξUnexpectedValueExceptionꤲ
function testUpdate_WithNonPositiveSectionNumber() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->update('test', 0, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('test', -1, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records = $index->update('test', -200, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('test', NULL, NULL, 'new');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 34(old_valuenew_value)˶ξUnexpectedValueExceptionꤲ
function testUpdate_WithEmptyOldValueAndEmptyNewValue() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = $index->update('test', 1, '', '');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('test', 1, NULL, NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('test', 1, '', NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records = $index->update('test', 1, NULL, '');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===
