--TEST--
Senna_Records - foreach iteration test for exceptions
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testForeach_CallsQueryMethods();
testForeach_CallsScoreOf();
testForeach_CallsSlice();

// foreach[vł̃Ce[gɃNGs\bhĂԂƁABadMethodCallException𓊂
function testForeach_CallsQueryMethods() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key1', NULL, 'test');
	$index->upd('key2', NULL, 'senna');
	$records->add('test');
	
	echo "### calls query methods\n";
	foreach ($records as $row) {
		try {
			$records->add('senna');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
		try {
			$records->adjust('senna');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
		try {
			$records->match('senna');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
		try {
			$records->remove('test');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
	}
	
	if ($records->count() != 1) {
		echo "failure: the Senna_Records object has been changed unexpectedly.\n";
	}

	Senna_Index::remove($path);
	unlink($path);
}

// Sennasen_records_find()֐͓J[\ړĂ܂B̎dlɂAforeachł̃Ce[gɌĂׂȂB
function testForeach_CallsScoreOf() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key1', NULL, 'test');
	$index->upd('key2', NULL, 'senna');
	$records->add('test');
	
	echo "### calls scoreOf()\n";
	foreach ($records as $row) {
		try {
			$records->scoreOf('test');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
		try {
			$records->scoreOf('senna');
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

/*
 * SennarecordśA_ANZXłȂB
 * ̐ɂAslice()\bh̓J[\擪ɖ߂ăV[PVANZXȂz𐶐B
 * J[\ړs߁Aforeachł̃Ce[gɌĂׂȂB
 */
function testForeach_CallsSlice() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key1', NULL, 'test');
	$index->upd('key2', NULL, 'senna');
	$records->add('test');
	
	echo "### calls slice()\n";
	foreach ($records as $row) {
		try {
			$records->slice(0, 1);
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
		
		try {
			$records->slice(1, 100);
			echo "The expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### calls query methods
### calls scoreOf()
### calls slice()
===DONE===