--TEST--
Senna_Records - foreach iteration test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testForeach_IteratesEmptyRecords();
testForeach_IteratesNonEmptyRecords();
testForeach_DescendingSortByScore();

// ̃R[hforeacɓnĂAPɉsȂBG[͔Ȃ
function testForeach_IteratesEmptyRecords() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');

	echo "### empty Senna_Records object\n";
	$records = new Senna_Records($index);
	if ($records->count() !== 0) {
		echo "failure: the Senna_Records object has unexpected record(s).\n";
	}
	
	// Senna_RecordsNX̏Ԃ͒g
	foreach ($records as $row) {
		// ̃R[hȂ̂foreach[v͎sȂ
		echo "failure: this was not supposed to be called.\n";
	}
	
	$records->add('test');     // ʂ3āc
	$records->match('senna');  // ς0ɖ߂B
	foreach ($records as $row) {
		// ̃R[hȂ̂foreach[v͎sȂ
		echo "failure: this was not supposed to be called.\n";
	}
	
	$records->add('test');     // ʂ3āc
	$records->remove('test');  // ς0ɖ߂B
	foreach ($records as $row) {
		// ̃R[hȂ̂foreach[v͎sȂ
		echo "failure: this was not supposed to be called.\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ʂ̓R[hforeachɓnƁAB
function testForeach_IteratesNonEmptyRecords() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');
	$index->upd('key004', NULL, 'senna 1');
	$index->upd('key005', NULL, 'senna 2');

	echo "### non-empty Senna_Records object\n";
	$records = new Senna_Records($index);
	$records->add('test');
	
	if ($records->count() !== 3) {
		echo "failure: the Senna_Records object does not have expected records.\n";
	}
	
	$counter = 0;
	foreach ($records as $i => $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if ($counter != 3) {
		printf("failure: expected iteration count is 3, %d given.\n", $counter);
	}
	
	$records->add('senna');    // ʂ2ǉđS5
	$counter = 0;
	foreach ($records as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if ($counter != 5) {
		printf("failure: expected iteration count is 5, %d given.\n", $counter);
	}
	
	$records->remove('test');  // 3炷
	$counter = 0;
	foreach ($records as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if ($counter != 2) {
		printf("failure: expected iteration count is 2, %d given.\n", $counter);
	}

	$records->match('senna');  // 2̂܂
	$counter = 0;
	foreach ($records as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if ($counter != 2) {
		printf("failure: expected iteration count is 2, %d given.\n", $counter);
	}
	
	Senna_Index::remove($path);
	unlink($path);
}


// XRAō~\[gʂԂ
function testForeach_DescendingSortByScore() {
	echo "### desc sort by score\n";
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');
	$index->upd('key004', NULL, 'senna 1');
	$index->upd('key005', NULL, 'senna 2');

	$records = new Senna_Records($index);
	$records->add('test');
	
	$prev = NULL;
	foreach ($records as $row) {
		$current = $row->getScore();
		if (is_null($prev)) {
			$prev = $current;
		}
		
		if ($prev < $current) {
			// XRAō~\[gĂ̂ŁA1ÕXRAȉ̒l̂͂
			echo "failure: the Senna_Records object is unsorted.\n";
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### empty Senna_Records object
### non-empty Senna_Records object
### desc sort by score
===DONE===