--TEST--
Senna_Records::__construct() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testConstructor_WithNoArgument();
testConstructor_WithNonSennaIndex();

testConstructor_WithInvalidRecordUnit();
testConstructor_WithInvalidSubRecordUnit();

testConstructor_WithNegativeNumberOfSubrecords();

// 1ĤʤInvalidArgumentExceptionꤲ
function testConstructor_WithNoArgument() {
	try {
		$records = new Senna_Records();
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}
}

// 1Senna_Index饹Υ󥹥󥹤ǤʤUnexpectedValueExceptionꤲ
function testConstructor_WithNonSennaIndex() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');

	try {
		$records = new Senna_Records(NULL);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	try {
		$records = new Senna_Records(array());
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	try {
		$records = new Senna_Records('Senna_Index');
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	try {
		$records = new Senna_Records(1);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	try {
		$records = new Senna_Records(new StdClass());
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	unlink($path);
}

// ̥쥳ɤñ̤Senna_Records::NONEϻǤʤ
function testConstructor_WithInvalidRecordUnit() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = new Senna_Records($index, Senna_Records::NONE);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ֥쥳ñ̤ϥᥤ쥳ñ̤꾮ΤǤʤ
function testConstructor_WithInvalidSubRecordUnit() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	// ֥쥳ñ̤ȥᥤ쥳ñ̤Ʊ礭
	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::DOCUMENT);
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::SECTION);
		$records = new Senna_Records($index, Senna_Records::POSISION, Senna_Records::POSISION);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}

	// ֥쥳ñ̤ᥤ쥳ñ̤礭
	try {
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::DOCUMENT);
		$records = new Senna_Records($index, Senna_Records::POSITION, Senna_Records::DOCUMENT);
		$records = new Senna_Records($index, Senna_Records::POSISION, Senna_Records::SECTION);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

function testConstructor_WithNegativeNumberOfSubrecords() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, -1);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "\n";
	} catch (Exception $expected) {
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===
