--TEST--
Senna_Records::__construct() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testConstructor_WithValidArguments();
testConstructor_HoldsSennaIndexByReference();

// ưάͤꤷƥ󥹥󥹲Ǥ뤳Ȥǧ롣
function testConstructor_WithValidArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);

	try {
		$records = new Senna_Records($index);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// ᥤ쥳ɤϡʸи֡Τ줫
	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT);
		$records = new Senna_Records($index, Senna_Records::SECTION);
		$records = new Senna_Records($index, Senna_Records::POSITION);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// ֥쥳ɤϡᥤ쥳ɤ꾮ñ̤ΤΡ
	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::POSITION);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE);
		
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::POSITION);
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::NONE);

		$records = new Senna_Records($index, Senna_Records::POSITION, Senna_Records::NONE);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

	// ֥쥳ɤϡᥤ쥳ɤ꾮ñ̤ΤΡ
	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::POSITION);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE);
		
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::POSITION);
		$records = new Senna_Records($index, Senna_Records::SECTION, Senna_Records::NONE);

		$records = new Senna_Records($index, Senna_Records::POSITION, Senna_Records::NONE);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

	// 祵֥쥳ɿϡ0ʾ͡
	// ֥쥳ñ̤Senna_Records::NONEξϥ֥쥳ɿϾ0
	// Senna_Records::NONEʳξSenna_Records::DEFAULT_MAX_N_SUBRECSꤵ줿ΤȲ᤹
	try {
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 0);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, Senna_Records::DEFAULT_MAX_N_SUBRECS);

		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE, 0);
		$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE, Senna_Records::DEFAULT_MAX_N_SUBRECS);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

/*
 * 󥹥ȥ饯ǻꤷSenna_Index֥ȤϡȤȤݻ롣
 * ΤᡢRecords֥˥ǥå򹹿ȡ
 * ȯԥ᥽åɤμ¹Է̤Ѥ롣
 */
function testConstructor_HoldsSennaIndexByReference() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$index->upd('key', NULL, 'test');

	$records = new Senna_Records($index);
	$records->add('test');
	echo $records->count(), "\n";  // ǥåˤϡtestפޤʸ1¸ߤ
	
	$index->upd('another', NULL, 'another test document');
	$records->add('test');
	echo $records->count(), "\n"; // ǥå줿Τǡ̤⤦1
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
1
2
===DONE===