--TEST--
Senna_Records::add() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testAdd_WithNoArguments();
testAdd_WithEmptyQuery();
testAdd_WithNonPositiveNumber();

// 1ĤʤInvalidArgumentExceptionꤲ
function testAdd_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->add();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testAdd_WithEmptyQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->add('');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->add(NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(ɡ黻ҸĿξ¿)0ʲξUnexpectedValueExceptionꤲ
function testAdd_WithNonPositiveNumber() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->add('test', 0);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->add('test', -1);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->add('test', -200);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->add('test', NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===
