--TEST--
Senna_Records::add() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testAdd_WithValidQuery1();
testAdd_WithValidQuery2();
testAdd_WithLimitedExpressions();

// ʸñ̤Ǥθ
function testAdd_WithValidQuery1() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	
	// add()ϸ̥쥳ɤ˥ޥå̤ɲä(̤˴¸ߤƤΤɲäʤ)
	echo "### valid query 1\n";
	try {
		echo $records->count(), "\n";

		$records->add('test');;
		echo $records->count(), "\n";
		
		echo $records->add('senna')->count(), "\n";
		echo $records->add('senna')->count(), "\n"; // ˥쥳¸ߤƤʸϽʣɲäʤ
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ñ̤Ǥθ
function testAdd_WithValidQuery2() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::SECTION);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	
	// add()ϸ̥쥳ɤ˥ޥå̤ɲä(̤˴¸ߤƤΤɲäʤ)
	echo "### valid query 2\n";
	try {
		echo $records->count(), "\n";

		$records->add('test');
		echo $records->count(), "\n";
		
		$records->add('senna');
		echo $records->count(), "\n";
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// 黻ҿꤹȡ¿ĶΥɤ̵뤹
function testAdd_WithLimitedExpressions() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'senna 1');
	$index->upd('key006', NULL, 'senna 2');
	$index->upd('key007', NULL, 'senna 3');
	$index->upd('key008', NULL, 'another senna 1');
	
	echo "### limited expressions\n";
	try {
		echo $records->count(), "\n";

		$records->add('test part one', 1);  // part oneפ̵뤹
		echo $records->count(), "\n";
		echo $records->getIgnoredQueryString(), "\n";
		
		$records->add('another senna test part two', 2); // for senna part twoפ̵뤹
		echo $records->count(), "\n";
		echo $records->getIgnoredQueryString(), "\n";
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### valid query 1
0
2
3
3
### valid query 2
0
4
6
### limited expressions
0
4
part one
5
test part two
===DONE===