--TEST--
Senna_Records::adjust() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testAdjust_WithNoArguments();
testAdjust_WithEmptyQuery();
testAdjust_WithNonPositiveNumber();

// 1ĤʤInvalidArgumentExceptionꤲ
function testAdjust_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->adjust();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testAdjust_WithEmptyQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->adjust('');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->adjust(NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(ɡ黻ҸĿξ¿)0ʲξUnexpectedValueExceptionꤲ
function testAdjust_WithNonPositiveNumber() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->adjust('test', 0);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->adjust('test', -1);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->adjust('test', -200);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->adjust('test', NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===
