--TEST--
Senna_Records::match() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testMatch_WithNoArguments();
testMatch_WithEmptyQuery();
testMatch_WithNonPositiveNumber();

// 1ĤʤInvalidArgumentExceptionꤲ
function testMatch_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->match();
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}


// 1ξUnexpectedValueExceptionꤲ
function testMatch_WithEmptyQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->match('');
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->match(NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(ɡ黻ҸĿξ¿)0ʲξUnexpectedValueExceptionꤲ
function testMatch_WithNonPositiveNumber() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	try {
		$records->match('test', 0);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	try {
		$records->match('test', -1);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->match('test', -200);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$records->match('test', NULL);
		echo "The expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

?>
===DONE===
--EXPECT--
===DONE===
