--TEST--
Senna_Records::match() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testMatch_WithValidQuery1();
testMatch_WithValidQuery2();
testMatch_WithLimitedExpressions();

// ʸñ̤Ǥθ
function testMatch_WithValidQuery1() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	
	echo "### valid query 1\n";
	try {
		echo $records->count(), "\n";

		echo $records->add('test')->count(), "\n";
		echo $records->match('senna')->count(), "\n";
		echo $records->match('none')->count(), "\n";  // ǥå˴ޤޤʤΤ0ˤʤ롣
		echo $records->match('none')->count(), "\n";  // 0ΤΤФƤ˹ʤߤƤ0Τޤ
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ñ̤Ǥθ
function testMatch_WithValidQuery2() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::SECTION);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	
	echo "### valid query 2\n";
	try {
		echo $records->count(), "\n";

		echo $records->add('test')->count(), "\n";
		echo $records->match('senna')->count(), "\n";
		echo $records->match('none')->count(), "\n";  // ǥå˴ޤޤʤΤ0ˤʤ롣
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// 黻ҿꤹȡ¿ĶΥɤ̵뤹
function testMatch_WithLimitedExpressions() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'senna 1');
	$index->upd('key006', NULL, 'senna 2');
	$index->upd('key007', NULL, 'senna 3');
	$index->upd('key008', NULL, 'another senna 1');
	
	echo "### limited expressions\n";
	try {
		echo $records->count(), "\n";

		echo $records->add('test OR senna')->count(), "\n";
		echo $records->match('test for senna', 1)->count(), "\n";  // for sennaפ̵뤹
		echo $records->getIgnoredQueryString(), "\n";
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### valid query 1
0
2
1
0
0
### valid query 2
0
4
1
0
### limited expressions
0
8
4
for senna
===DONE===