--TEST--
Senna_Records::remove() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testRemove_WithValidQuery1();
testRemove_WithValidQuery2();
testRemove_WithLimitedExpressions();

// ʸñ̤Ǥθ
function testRemove_WithValidQuery1() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	$records->add('test OR senna');
	
	echo "### valid query 1\n";
	try {
		echo $records->count(), "\n";  // key001, key002, key003ޤޤ

		$records->remove('test -senna'); // key001롣key002ϡsennaפޤʸΤоݳ
		echo $records->count(), "\n";
		
		echo $records->remove('senna')->count(), "\n";  // 0ˤʤ롣
		echo $records->remove('none')->count(), "\n";  // 0ΤΤ¹ԤƤ0Τޤ
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ñ̤Ǥθ
function testRemove_WithValidQuery2() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::SECTION);
	
	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key002', 1, NULL, 'test 3');
	$index->update('key002', 7, NULL, 'senna test');
	$index->update('key003', 1, NULL, 'senna 1');
	$index->update('key003', 2, NULL, 'senna 2');
	$index->update('key004', 1, NULL, '12345');
	$records->add('test OR senna');
	
	echo "### valid query 2\n";
	try {
		echo $records->count(), "\n";

		$records->remove('test -senna');;
		echo $records->count(), "\n";
		
		$records->remove('senna');
		echo $records->count(), "\n";
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// 黻ҿꤹȡ¿ĶΥɤ̵뤹
function testRemove_WithLimitedExpressions() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test 1');
	$index->upd('key002', NULL, 'test 2');
	$index->upd('key003', NULL, 'test 3');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'senna 1');
	$index->upd('key006', NULL, 'senna 2');
	$index->upd('key007', NULL, 'senna 3');
	$index->upd('key008', NULL, 'another senna 1');
	$records->add('test OR senna');
	
	echo "### limited expressions\n";
	try {
		echo $records->count(), "\n";

		$records->remove('test part one', 1);  // part oneפ̵뤹
		echo $records->count(), "\n";
		echo $records->getIgnoredQueryString(), "\n";
		
		$records->remove('another senna test part two', 2); // for senna part twoפ̵뤹
		echo $records->count(), "\n";
		echo $records->getIgnoredQueryString(), "\n";
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### valid query 1
3
2
0
0
### valid query 2
6
3
0
### limited expressions
8
4
part one
3
test part two
===DONE===