--TEST--
Senna_Records::scoreOf() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testScoreOf_ReturnsScore();
testScoreOf_ReturnsZero();

// ̤¸ߤkeyʤ顢֤
function testScoreOf_ReturnsScore() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	$records->add('test');
	
	echo "### returns non-zero score\n";
	try {
		foreach (array('key001', 'key002', 'key003', 'key004') as $key) {
			// ̤¸ߤ륭ϡ0礭ͤΥ֤
			if ($records->scoreOf($key) === 0) {
				echo "failure: unexpected score has been returned.\n";
			}
		}
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ̤¸ߤʤkeyʤ顢0
function testScoreOf_ReturnsZero() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	$records->add('test');
	
	echo "### returns zero\n";
	try {
		foreach (array('key005', 'NonExistentKey') as $key) {
			// ̤¸ߤ륭ϡ0礭ͤΥ֤
			if ($records->scoreOf($key) !== 0) {
				echo "failure: unexpected score has been returned.\n";
			}
		}
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### returns non-zero score
### returns zero
===DONE===