--TEST--
Senna_Records::setLimit() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testSetLimit_CallsBeforeQuery();
testSetLimit_CallsAfterQuery();

testSetLimit_Increment();
testSetLimit_Decrement();

testSetLimit_WithZero();

// ̤˥쥳ɿ¤
function testSetLimit_CallsBeforeQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	
	echo "### before query\n";
	
	try {
		$records->setLimit(3); // ȯ˸̿¤
	} catch (Exception $unexpected) {
		echo "failure1: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	$records->add('test');  // ȯ

	if (3 != $records->count()) {
		echo "failure2: unexpected count() == ", $records->count(), "\n";
	}
	
	for ($i = 0; $i < 2; $i++) {
		// 󥤥ƥ졼ȤƤ
		$counter = 0;
		foreach ($records as $r) {
			$counter++;  // ºݤݻƤǧ
		}
		if (3 != $counter) {
			echo "failure3: object has unexpected records.\n";
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ̤˥쥳ɿ¤
function testSetLimit_CallsAfterQuery() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	$records->add('test');  // ˥ȯ

	echo "### after query\n";

	if (4 != $records->count()) {
		echo "failure1: unexpected count() == ", $records->count(), "\n";
	}
	
	try {
		$records->setLimit(3); // 夫
	} catch (Exception $unexpected) {
		echo "failure2: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (3 != $records->count()) {
		echo "failure3: unexpected count() == ", $records->count(), "\n";
	}
	
	for ($i = 0; $i < 2; $i++) {
		// 󥤥ƥ졼ȤƤ
		$counter = 0;
		foreach ($records as $r) {
			$counter++;  // ºݤݻƤǧ
		}
		if (3 != $counter) {
			echo "failure4: object has unexpected records.\n";
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ȯԸ˾ͤäƤ⡢ʤʬϰϤΥ쥳ɤǤ
function testSetLimit_Increment() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	$records->add('test');
	
	echo "### increment\n";
	
	if (4 != $records->count()) {
		echo "failure1: unexpected count() == ", $records->count(), "\n";
	}

	// ޤ3¤
	try {
		$records->setLimit(3);
	} catch (Exception $unexpected) {
		echo "failure2: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (3 != $records->count()) {
		echo "failure3: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (3 != $counter) {
		echo "failure4: object has unexpected records.\n";
	}
	
	// 4ä
	try {
		$records->setLimit(4);
	} catch (Exception $unexpected) {
		echo "failure5: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (4 != $records->count()) {
		echo "failure6: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (4 != $counter) {
		echo "failure7: object has unexpected records.\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ȯԸ˾ͤ򸺾ȡʬϰϤΥ쥳ɤϼǤʤʤ
function testSetLimit_Decrement() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	$records->add('test');
	echo "### decrement\n";
	
	if (4 != $records->count()) {
		echo "failure1: unexpected count() == ", $records->count(), "\n";
	}
	
	// ޤ3¤
	try {
		$records->setLimit(3);
	} catch (Exception $unexpected) {
		echo "failure2: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (3 != $records->count()) {
		echo "failure3: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (3 != $counter) {
		echo "failure4: object has unexpected records.\n";
	}
	
	// 2˸
	try {
		$records->setLimit(2);
	} catch (Exception $unexpected) {
		echo "failure5: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (2 != $records->count()) {
		echo "failure6: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (2 != $counter) {
		echo "failure7: object has unexpected records.\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ¿0ꤹȡ̤ξ¿̵¤ˤʤ
function testSetLimit_WithZero() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);
	
	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	
	echo "### zero\n";
	
	// ޤ1¤
	try {
		$records->setLimit(1);
	} catch (Exception $unexpected) {
		echo "failure1: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	$records->add('test');
	
	if (1 != $records->count()) {
		echo "failure2: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (1 != $counter) {
		echo "failure3: object has unexpected records.\n";
	}
	
	// 0ꤷ̵¤ꤹ
	try {
		$records->setLimit(0);
	} catch (Exception $unexpected) {
		echo "failure4: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (4 != $records->count()) {
		echo "failure5: unexpected count() == ", $records->count(), "\n";
	}
	
	$counter = 0;
	foreach ($records as $r) {
		$counter++;  // ºݤݻƤǧ
	}
	if (4 != $counter) {
		echo "failure6: object has unexpected records.\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### before query
### after query
### increment
### decrement
### zero
===DONE===