--TEST--
Senna_Records::slice() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testSlice_InRange();
testSlice_OffsetIsOutOfUpperBound();
testSlice_ReturnedArraySizeIsLessThanCount();

testSlice_EmptyRecordsReturnsEmptyArray();

// ¸ߤ륪եåȤȼºݤ˼ǽʷꤷƼ
function testSlice_InRange() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	
	$records->add('test');
	
	$slicedList = array();
	try {
		$slicedList = $records->slice(0, 3);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (count($slicedList) != 3) {
		echo "failure: unexpected count(\$slicedList) == ", count($slicedList), "\n";
	}
	
	$counter = 0;
	foreach ($slicedList as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if (3 != $counter) {
		echo "failure: unexpected \$counter value == ", $counter, "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ºݤ˼ǽʷĶեåȤꤷϡ֤
function testSlice_OffsetIsOutOfUpperBound() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	
	$records->add('test');
	
	$slicedList = array();
	try {
		$slicedList = $records->slice(10, 1);  // ̤4路ʤեåȤ10
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (count($slicedList) != 0) {
		echo "failure: unexpected count(\$slicedList) == ", count($slicedList), "\n";
	}
	
	$counter = 0;
	foreach ($slicedList as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if (0 != $counter) {
		echo "failure: unexpected \$counter value == ", $counter, "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ºݤݻƤ쥳ɿcountǻꤷ꾯ʤϡ֤ʬǤ֤
function testSlice_ReturnedArraySizeIsLessThanCount() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key001', NULL, 'test');
	$index->upd('key002', NULL, 'test test');
	$index->upd('key003', NULL, 'test test test');
	$index->upd('key004', NULL, 'senna test');
	$index->upd('key005', NULL, 'another');
	
	$records->add('test');
	
	$slicedList = array();
	try {
		$slicedList = $records->slice(0, 100);  // ̤4路ʤcount100
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (count($slicedList) != 4) {
		echo "failure: unexpected count(\$slicedList) == ", count($slicedList), "\n";
	}
	
	$counter = 0;
	foreach ($slicedList as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if (4 != $counter) {
		echo "failure: unexpected \$counter value == ", $counter, "\n";
	}

	// offset0ʳꤷѥΥƥ
	$slicedList = array();
	try {
		$slicedList = $records->slice(2, 10);
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (count($slicedList) != 2) {
		echo "failure: unexpected count(\$slicedList) == ", count($slicedList), "\n";
	}
	
	$counter = 0;
	foreach ($slicedList as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if (2 != $counter) {
		echo "failure: unexpected \$counter value == ", $counter, "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// Υ쥳ɤФslice()¹Ԥȡ֤
function testSlice_EmptyRecordsReturnsEmptyArray() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$slicedList = NULL;
	try {
		// ȯԤƤʤΤǡ$recordsϽ֤ζΤޤ
		$slicedList = $records->slice(0, 100);
	} catch (Exception $unexpected) {
		echo "empty records: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	if (! empty($slicedList)) {
		echo "empty records: unexpected rows has been retunred.\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
===DONE===