--TEST--
Senna_Records_Row - getter methods test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testGetter_MethodCallStyle();
testGetter_HashKeyStyle();

// ݻƤ֤ͤ(᥽åɷǤθƤӽФ)
function testGetter_MethodCallStyle() {
	echo "### method call style\n";
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key001', NULL, 'test');
	$records->add('test');
	
	try {
		foreach (array($records, $records->slice(0, 1)) as $target) {
			foreach ($target as $row) {
				if ('key001' != $row->getKey()) {
					echo "getKey(): unexpected key.\n";
				}
				// keysizestrlen()ͤǤϤʤʸ󤬳ݤƤbyteNULLޤ
				if (7 != $row->getKeySize()) {
					echo "getKeySize(): unexpected key_size.\n";
				}
				if (! is_int($row->getScore())) {
					echo "getScore(): unexpected score.\n";
				}
				if (! is_int($row->getSection())) {
					echo "getSection(): unexpected section.\n";
				}
				if (! is_int($row->getPosition())) {
					echo "getPosition(): unexpected position.\n";
				}
				if (0 !== $row->getSubrecordCount()) {
					echo "getSubrecordsCount(): unexpected subrecords_count.\n";
				}
				$subrecords = $row->getSubrecords();
				if (! $subrecords instanceof Senna_Records_Subrecords) {
					echo "getSubrecords(): unexpected type.\n";
				}
				if (0 !== $subrecords->count()) {
					echo "getSubrecords() is expected empty array.\n";
				}
			}
		}
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ݻƤ֤ͤ(ϥåǤμ)
function testGetter_HashKeyStyle() {
	echo "### hash key style\n";
	if (! interface_exists('ArrayAccess')) {
		return;
	}
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->upd('key001', NULL, 'test');
	$records->add('test');
	
	try {
		foreach (array($records, $records->slice(0, 1)) as $target) {
			foreach ($target as $row) {
				// ϥå奭˼ͤ̾ꤹ롣ʸʸ϶̤ʤ
				if (! isset($row['key'])) {
					echo "\$row does not have 'key'.\n";
				} else if (! isset($row['keySize'])) {
					echo "\$row does not have 'keysize'.\n";
				} else if (! isset($row['Score'])) {
					echo "\$row does not have 'score'.\n";
				} else if (! isset($row['sectiON'])) {
					echo "\$row does not have 'section'.\n";
				} else if (! isset($row['position'])) {
					echo "\$row does not have 'position'.\n";
				} else if (! isset($row['subrecords'])) {
					echo "\$row does not have 'subrecords'.\n";
				} else if (! isset($row['subrecordCount'])) {
					echo "\$row does not have 'subrecordCount'.\n";
				} elseif (isset($row['nonExistentkey'])) {
					echo "\$row has unknown key 'nonexistentkey'.\n";
				}
				
				
				if ('key001' != $row["key"]) {
					echo "getKey(): unexpected key.\n";
				}
				if (7 != $row['KEYSIZE']) {
					echo "getKeySize(): unexpected key_size.\n";
				}
				if (! is_int($row['Score'])) {
					echo "getScore(): unexpected score.\n";
				}
				if (! is_int($row['SectiON'])) {
					echo "getSection(): unexpected section.\n";
				}
				if (! is_int($row['Position'])) {
					echo "getPosition(): unexpected position.\n";
				}
				if (0 !== $row['SubrecordCount']) {
					echo "getSubrecordsCount(): unexpected subrecord_count.\n";
				}
				if (! $row['Subrecords'] instanceof Senna_Records_Subrecords) {
					echo "getSubrecords(): unexpected type.\n";
				}
				if (0 !== $row['Subrecords']->count()) {
					echo "getSubrecords() is expected empty array.\n";
				}
			}
		}
	} catch (Exception $unexpected) {
		echo "failure: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### method call style
### hash key style
===DONE===