--TEST--
Senna_Records_SubRecords - foreach iteration test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testForeach_IteratesEmptyRecords();
testForeach_IteratesNonEmptyRecords();

// Υ֥쥳ɤforeachϤƤⲿ¹Ԥʤ
function testForeach_IteratesEmptyRecords() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE);
	
	$index->update('key001', 1, NULL, 'test 1-1');
	$index->update('key001', 2, NULL, 'test 1-2');
	$index->update('key002', 1, NULL, 'test 2-1');
	$index->update('key002', 2, NULL, 'test 2-2');
	$index->update('key002', 3, NULL, 'test 2-3');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### empty subrecords\n";

	$subRecords = $row->getSubRecords();
	try {
		foreach ($subRecords as $row) {
			// Υ쥳ɤʤΤforeach롼ϼ¹Ԥʤ
			echo "This line was not supposed to be called.\n";
		}
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ֥쥳ɤä֥ȤforeachϤȡȿ򤹤롣
function testForeach_IteratesNonEmptyRecords() {
	$MAX_SUBRECS = 3;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### non-empty subrecords\n";

	$subRecords = $row->getSubRecords();
	$counter = 0;
	try {
		foreach ($subRecords as $subRow) {
			if ($subRow instanceof Senna_Records_Row) {
				$counter++;
				if (0 != $subRow->getSubRecordCount()) {
					echo "unexpected getSubRecordCount()\n";
				}
				$subSubRecords = $subRow->getSubRecords();
				if (0 != $subSubRecords->count()) {
					echo "unexpected getSubRecords()\n";
				}
			}
		}
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if (3 != $counter) {
		printf("failure: expected iteration count is 3, %d given.\n", $counter);
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### empty subrecords
### non-empty subrecords
===DONE===