--TEST--
Senna_Records_SubRecords::count() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testCount_MethodCallStyle_ReturnsZero();
testCount_MethodCallStyle_ReturnsCount();
testCount_FunctionCallStyle();  // SPLͭʾ硢Countable󥿡եƤ

// Υ֥쥳ɤcount()Ƥ֤ȡ0֤
function testCount_MethodCallStyle_ReturnsZero() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::NONE);

	$index->update('key001', 1, NULL, 'test 1-1');
	$index->update('key001', 2, NULL, 'test 1-2');
	$index->update('key002', 1, NULL, 'test 2-1');
	$index->update('key002', 2, NULL, 'test 2-2');
	$index->update('key002', 3, NULL, 'test 2-3');
	$rows = $records->add('test')->slice(0, 10);
	
	echo "### method call style (returns zero)\n";

	$subRecords = $rows[0]->getSubrecords();
	try {
		if (0 != $subRecords->count()) {
			echo 'unexpected count() in ', __FUNCTION__, "()\n";
		}
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ǤϤʤ֥쥳ɤcount()Ƥ֤ȡ֥쥳ɿ֤
function testCount_MethodCallStyle_ReturnsCount() {
	$MAX_SUBRECS = 2;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1-1');
	$index->update('key001', 2, NULL, 'test 1-2');
	$index->update('key002', 1, NULL, 'test 2-1');
	$index->update('key002', 2, NULL, 'test 2-2');
	$index->update('key002', 3, NULL, 'test 2-3');
	$index->update('key003', 7, NULL, 'test 3-7');
	
	echo "### method call style (returns count)\n";

	foreach ($records as $row) {
		try {
			$count = $row->getSubRecords()->count();
			if ($MAX_SUBRECS < $count) {
				echo 'unexpected count() in ', __FUNCTION__, "()\n";
			}
			
			switch ($row->getKey()) {
				case 'key001':
					if (2 != $count) {
						echo 'key001: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				case 'key002':
					// $MAX_SUBRECS == 2ʤΤǡ3ĸФ줿ȤƤ2ĤޤǤäƤʤ
					if (2 != $count) {
						echo 'key002: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				case 'key003':
					if (1 != $count) {
						echo 'key003: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				default:
					break;
			}
		} catch (Exception $unexpected) {
			echo $unexpected->getMessage(), "\n";
		}
	}

	Senna_Index::remove($path);
	unlink($path);
}

function testCount_FunctionCallStyle() {
	$MAX_SUBRECS = 2;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1-1');
	$index->update('key001', 2, NULL, 'test 1-2');
	$index->update('key002', 1, NULL, 'test 2-1');
	$index->update('key002', 2, NULL, 'test 2-2');
	$index->update('key002', 3, NULL, 'test 2-3');
	$index->update('key003', 7, NULL, 'test 3-7');
	$rows = $records->add('test')->slice(0, 10);
	
	echo "### function call style\n";

	if (! interface_exists('Countable')) {
		return;
	}
	
	foreach ($records as $row) {
		try {
			$count = count($row->getSubRecords());
			if ($MAX_SUBRECS < $count) {
				echo 'unexpected count() in ', __FUNCTION__, "()\n";
			}
			
			switch ($row->getKey()) {
				case 'key001':
					if (2 != $count) {
						echo 'key001: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				case 'key002':
					// $MAX_SUBRECS == 2ʤΤǡ3ĸФ줿ȤƤ2ĤޤǤäƤʤ
					if (2 != $count) {
						echo 'key002: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				case 'key003':
					if (1 != $count) {
						echo 'key003: unexpected count() in ', __FUNCTION__, "()\n";
					}
					break;
				default:
					break;
			}
		} catch (Exception $unexpected) {
			echo $unexpected->getMessage(), "\n";
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

?>
===DONE===
--EXPECT--
### method call style (returns zero)
### method call style (returns count)
### function call style
===DONE===