--TEST--
Senna_Records_SubRecords - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testGet_WithNegativeOffset();
testGet_OffsetIsOutOfUpperBound();

// ΥեåͤꤹȡOutOfBoundsExceptionꤲ
function testGet_WithNegativeOffset() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 3);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### negative offset\n";

	$subRecords = $row->getSubRecords();
	try {
		$row = $subRecords->get(-1);
		echo "method call style: the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	if (interface_exists('ArrayAccess')) {
		try {
			$row = $subRecords[-1];
			echo "hash key style: the expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ݻƤ륵֥쥳ɿĶ륪եåȤꤹȡOutOfBoundsExceptionꤲ
function testGet_OffsetIsOutOfUpperBound() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 3);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### out of upper bound\n";

	$subRecords = $row->getSubRecords();
	$lastOffset = $subRecords->count() - 1;
	try {
		$row = $subRecords->get($lastOffset + 1);
		echo "method call style: the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	if (interface_exists('ArrayAccess')) {
		try {
			$row = $subRecords[$lastOffset + 1];
			echo "hash key style: the expected exception has not been thrown.\n";
		} catch (Exception $expected) {
		}
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### negative offset
### out of upper bound
===DONE===