--TEST--
Senna_Records_SubRecords::get() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testGet_MethodCallStyle();
testGet_HashKeyStyle();

// ݻƤ֤ͤ(᥽åɷǤθƤӽФ)
function testGet_MethodCallStyle() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 3);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### method call style\n";

	$subRecords = $row->getSubRecords();
	try {
		$row = $subRecords->get(1);
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if (! ($row instanceof Senna_Records_Row)) {
		echo 'unexpected get() in', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ݻƤ֤ͤ(ϥåǤμ)
function testGet_HashKeyStyle() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 3);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### hash key style\n";
	if (! interface_exists('ArrayAccess')) {
		return;
	}
	
	$subRecords = $row->getSubRecords();
	try {
		if (isset($subRecords[100])) {
			echo "hash key style: the object has unexpected offset(s).\n";
		}
		if (!isset($subRecords[1])) {
			echo "hash key style: the object does not have an expected offset.\n";
		}
		$row = $subRecords[1];
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if (! ($row instanceof Senna_Records_Row)) {
		echo 'unexpected get() in', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### method call style
### hash key style
===DONE===