--TEST--
Senna_Records_SubRecords::slice() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testSlice_WithNoArguments();
testSlice_WithNegativeOffset();
testSlice_WithNonPositiveCount();

// 1ĤʤInvalidArgumentExceptionꤲ
function testSlice_WithNoArguments() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 10);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### no args\n";

	$subRecords = $row->getSubRecords();
	try {
		$subRecords->slice();
		echo "no args: the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	Senna_Index::remove($path);
	unlink($path);
}


// 1(offset)ͤξUnexpectedValueExceptionꤲ
function testSlice_WithNegativeOffset() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 10);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### negative offset\n";

	$subRecords = $row->getSubRecords();
	try {
		$subRecords->slice(-1, 1);
		echo "negative offset(-1): the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$subRecords->slice(-100, 1);
		echo "negative offset(-100): the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}

// 2(count)1ʾͤǤʤUnexpectedValueExceptionꤲ
function testSlice_WithNonPositiveCount() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, 10);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### non-positive count\n";

	$subRecords = $row->getSubRecords();
	try {
		$subRecords->slice(0, 0);
		echo "non-positive count(0): the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}
	
	try {
		$subRecords->slice(0, -1);
		echo "non-positive count(-1): the expected exception has not been thrown.\n";
	} catch (Exception $expected) {
	}

	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### no args
### negative offset
### non-positive count
===DONE===
