--TEST--
Senna_Records_SubRecords::slice() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testSlice_InRange();
testSlice_OffsetIsOutOfUpperBound();
testSlice_ReturnedArraySizeIsLessThanCount();

testSlice_EmptySubRecordsReturnsEmptyArray();

// ¸ߤ륪եåȤȼºݤ˼ǽʷꤷƼ
function testSlice_InRange() {
	$MAX_SUBRECS = 3;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### in range\n";

	$subRecords = $row->getSubRecords();
	$slicedList = NULL;
	try {
		$slicedList = $subRecords->slice(1, 2);
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	$counter = 0;
	foreach ($slicedList as $row) {
		if ($row instanceof Senna_Records_Row) {
			$counter++;
		}
	}
	if (2 != $counter) {
		echo 'failed in ', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ºݤ˼ǽʷĶեåȤꤷϡ֤
function testSlice_OffsetIsOutOfUpperBound() {
	$MAX_SUBRECS = 3;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### out of upper bound\n";

	$subRecords = $row->getSubRecords();
	$slicedList = NULL;
	try {
		$slicedList = $subRecords->slice(10, 2);
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if ((! is_array($slicedList)) or (0 != count($slicedList))) {
		echo 'failed in ', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// ºݤݻƤ쥳ɿcountǻꤷ꾯ʤϡ֤ʬǤ֤
function testSlice_ReturnedArraySizeIsLessThanCount() {
	$MAX_SUBRECS = 3;
	
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index, Senna_Records::DOCUMENT, Senna_Records::SECTION, $MAX_SUBRECS);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### array size is less than count\n";

	$subRecords = $row->getSubRecords();
	$slicedList = NULL;
	try {
		$slicedList = $subRecords->slice(1, 1000);
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if ((! is_array($slicedList)) or (2 != count($slicedList))) {
		echo 'failed in ', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}

// Υ쥳ɤФslice()¹Ԥȡ֤
function testSlice_EmptySubRecordsReturnsEmptyArray() {
	$path = tempnam(sys_get_temp_dir(), 'php_senna-test');
	$index = new Senna_Index($path);
	$records = new Senna_Records($index);

	$index->update('key001', 1, NULL, 'test 1');
	$index->update('key001', 2, NULL, 'test 2');
	$index->update('key001', 3, NULL, 'test 3');
	$index->update('key001', 4, NULL, 'test 4');
	$records->add('test');
	list($row) = $records->slice(0, 1);
	
	echo "### empty array\n";

	$subRecords = $row->getSubRecords();
	$slicedList = NULL;
	try {
		$slicedList = $subRecords->slice(0, 1000);
	} catch (Exception $unexpected) {
		echo $unexpected->getMessage(), "\n";
	}
	
	if ((! is_array($slicedList)) or (0 != count($slicedList))) {
		echo 'failed in ', __FUNCTION__, "()\n";
	}
	
	Senna_Index::remove($path);
	unlink($path);
}
?>
===DONE===
--EXPECT--
### in range
### out of upper bound
### array size is less than count
### empty array
===DONE===