--TEST--
Senna_Snippet::__construct() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testConstructor_WithValidArguments();

// ưάͤꤷƥ󥹥󥹲Ǥ뤳Ȥǧ롣
function testConstructor_WithValidArguments() {
	// encoding
	try {
		foreach (array(Senna::ENC_DEFAULT, Senna::ENC_NONE, Senna::ENC_EUC_JP, Senna::ENC_UTF8, Senna::ENC_SJIS) as $enc) {
			$snip = new Senna_Snippet($enc, 0, 100);
		}
	} catch (Exception $unexpected) {
		echo "encoding: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// flags
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, NULL, 100);
	} catch (Exception $unexpected) {
		echo "flags: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// width
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 1);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 1024);
	} catch (Exception $unexpected) {
		echo "width: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// max_results
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, Senna_Snippet::MAX_RESULT_COUNT);
	} catch (Exception $unexpected) {
		echo "max_results: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// defaultOpenTag
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '');
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>');
	} catch (Exception $unexpected) {
		echo "defaultOpenTag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// defaultCloseTag
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '');
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '<close />');
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>');
	} catch (Exception $unexpected) {
		echo "defaultCloseTag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

	// mapping
	try {
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '', NULL);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '<close />', NULL);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>', NULL);

		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '', Senna_Snippet::MAPPING_NONE);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '<close />', Senna_Snippet::MAPPING_NONE);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>', Senna_Snippet::MAPPING_NONE);

		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '', Senna_Snippet::MAPPING_COMPAT);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '', '<close />', Senna_Snippet::MAPPING_COMPAT);
		$snip = new Senna_Snippet(Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>', Senna_Snippet::MAPPING_COMPAT);
	} catch (Exception $unexpected) {
		echo "mapping: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
}
?>
===DONE===
--EXPECT--
===DONE===