--TEST--
Senna_Snippet::addKeyword() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testAddKeyword_ReturnsKeywordCount();

testAddKeyword_AddsSameKeyword();

testAddKeyword_UsesDefaultTags();
testAddKeyword_WithOpenTag();
testAddKeyword_WithCloseTag();
testAddKeyword_WithOpenAndCloseTag();

// ɿ֤
function testAddKeyword_ReturnsKeywordCount() {
	echo "### returns keyword count\n";
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
	try {
		$snip->addKeyword('test');
		echo $snip->getKeywordCount(), "\n";
		echo $snip
			->addKeyword('another')
			->addKeyword('senna')
			->addKeyword('senna')
			->getKeywordCount(), "\n";
		for ($i = 5; $i <= Senna_Snippet::MAX_KEYWORD_COUNT; $i++) {
			$snip->addKeyword('padding' . $i);
		}
	} catch (Exception $unexpected) {
		echo "keyword count: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
}

// ƱɤɲäưϸǤSennaμ¸
function testAddKeyword_AddsSameKeyword() {
	echo "### adds same keyword\n";
	// Senna-1.1.1λͤȡɲäɤͥ褵줿
}


// 23ά(󥹥ȥ饯ǻꤷ)ǥեȤγϡĤȤ
function testAddKeyword_UsesDefaultTags() {
	echo "### uses default tags\n";
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');

	try {
		$snip->addKeyword('senna');
	} catch (Exception $unexpected) {
		echo "default tags: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	$resultList = $snip->execute('this/is/senna/.');
	echo $resultList[0], "\n";

	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 5, 1, '<b>', '</b>');

	try {
		$snip->addKeyword('senna');
	} catch (Exception $unexpected) {
		echo "default tags: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	$resultList = $snip->execute('this/is/senna/.');
	echo $resultList[0], "\n";
}

// 2ꤹȡɤФƤϻꤷϥȤ
function testAddKeyword_WithOpenTag() {
	echo "### uses specified open tag\n";
	
	// ꡣ''NULLϰ㤦''϶ʸ򥿥ȤƻȤNULLϥǥեȥȤ
	foreach (array('<open>', '', NULL) as $openTag) {
		$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
		try {
			$snip->addKeyword('senna', $openTag);
		} catch (Exception $unexpected) {
			echo "open tag: unexpected exception has been thrown.\n";
			echo $unexpected->getMessage(), "\n";
		}
		
		$resultList = $snip->execute('this/is/senna/.');
		echo $resultList[0], "\n";
		unset($snip);
	}
	
}

// 3ꤹȡɤФƤϻꤷĤȤ
function testAddKeyword_WithCloseTag() {
	echo "### uses specified close tag\n";

	// ꡣ''NULLϰ㤦''϶ʸ򥿥ȤƻȤNULLϥǥեȥȤ
	foreach (array('</close>', '', NULL) as $closeTag) {
		$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
		try {
			$snip->addKeyword('senna', NULL, $closeTag);
		} catch (Exception $unexpected) {
			echo "open tag: unexpected exception has been thrown.\n";
			echo $unexpected->getMessage(), "\n";
		}
		
		$resultList = $snip->execute('this/is/senna/.');
		echo $resultList[0], "\n";
		unset($snip);
	}
}

// 23ꤹȡɤФƤϻꤷĤȤ
function testAddKeyword_WithOpenAndCloseTag() {
	echo "### uses specified tags\n";
	
	// NULLŪ˻
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
	try {
		$snip->addKeyword('senna', NULL, NULL);
	} catch (Exception $unexpected) {
		echo "open tag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	$resultList = $snip->execute('this/is/senna/.');
	echo $resultList[0], "\n";

	// ʸ
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
	try {
		$snip->addKeyword('senna', '', '');
	} catch (Exception $unexpected) {
		echo "open tag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	$resultList = $snip->execute('this/is/senna/.');
	echo $resultList[0], "\n";

	// 
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
	try {
		$snip->addKeyword('senna', '<tag>', '</tag>');
	} catch (Exception $unexpected) {
		echo "open tag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	$resultList = $snip->execute('this/is/senna/.');
	echo $resultList[0], "\n";
}
?>
===DONE===
--EXPECT--
### returns keyword count
1
4
### adds same keyword
### uses default tags
this/is/<b>senna</b>/.
<b>senna</b>
### uses specified open tag
this/is/<open>senna</b>/.
this/is/senna</b>/.
this/is/<b>senna</b>/.
### uses specified close tag
this/is/<b>senna</close>/.
this/is/<b>senna/.
this/is/<b>senna</b>/.
### uses specified tags
this/is/<b>senna</b>/.
this/is/senna/.
this/is/<tag>senna</tag>/.
===DONE===