--TEST--
Senna_Snippet::createQuerySnippet() - invalid arguments test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testCreateQuerySnippet_WithShortArguments();

testCreateQuerySnippet_WithEmptyQuery();
testCreateQuerySnippet_WithNonPositiveExpressions();

testCreateQuerySnippet_WithUnsupportedEncoding();
testCreateQuerySnippet_WithCopyTagFlag();
testCreateQuerySnippet_WithNonPositiveWidth();
testCreateQuerySnippet_WithNonPositiveResultCount();

testCreateQuerySnippet_WithInvalidMappingArgument();

testCreateQuerySnippet_WithQueryKeywordExceedingWidth();

// 6̤ǤInvalidArgumentExceptionꤲ
function testCreateQuerySnippet_WithShortArguments() {
	echo "### short arguments\n";
	// 0
	try {
		$snip = Senna_Snippet::createQuerySnippet();
		echo "0: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	// 1
	try {
		$snip = Senna_Snippet::createQuerySnippet('test');
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	// 2
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS);
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	// 3
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT);
		echo "3: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	// 4
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, 0);
		echo "4: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 1ΥξUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithEmptyQuery() {
	echo "### arg1\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, 0, 100);
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	
	try {
		$snip = Senna_Snippet::createQuerySnippet(NULL, Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, 0, 100);
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 2(祭ɿ)ͤǤʤUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithNonPositiveExpressions() {
	echo "### arg2\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 0, Senna::ENC_DEFAULT, 0, 100);
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', -1, Senna::ENC_DEFAULT, 0, 100);
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', -200, Senna::ENC_DEFAULT, 0, 100);
		echo "3: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 3̤бΥ󥳡ɥפξUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithUnsupportedEncoding() {
	echo "### arg3\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, -1, 0, 100);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 4SEN_SNIP_COPY_TAG(0x0002)ꤷϡUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithCopyTagFlag() {
	echo "### arg4\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0x0002, 100);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 51̤ꤷϡUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithNonPositiveWidth() {
	echo "### arg5\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 0);
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}

	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, -1);
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 61̤ꤷϡUnexpectedValueExceptionꤲ
function testCreateQuerySnippet_WithNonPositiveResultCount() {
	echo "### arg6\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, 0);
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}

	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, -1);
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// 9NULLͰʳΥפꤷϡInvalidArgumentExceptionꤲ
function testCreateQuerySnippet_WithInvalidMappingArgument() {
	echo "### arg9\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, -1, '<b>', '</b>', array());
		echo "1: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
	
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, -1, '<b>', '</b>', new StdClass());
		echo "2: the expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}

// widthĶĹΥɤ˴ޤޤƤȡSennaExceptionꤲ(Senna-1.1.0ΥСѤƤ)
function testCreateQuerySnippet_WithQueryKeywordExceedingWidth() {
	echo "### exceeding\n";
	/*
	 * Senna-1.1.0ΥСѤƤ硧
	 * widthĶĹΥɤޤޤƤ㳰ꤲ
	 * Senna-1.1.0ʹߤΥС
	 * widthĶĹΥɤ̵뤹롣㳰ꤲʤ
	 * sen_query_term()Sementation FaultХѤǤʤä١ư㤦
	 */
	if (version_compare("1.1.0", Senna::API_VERSION, "<=")) {
		return;
	}
	
	try {
		$snip = Senna_Snippet::createQuerySnippet('test QueryKeywordLengthExceededWidth', 3, Senna::ENC_DEFAULT, 0, 10);
		echo "The expected exception has not been thrown in ", __FUNCTION__, "()\n";
	} catch (Exception $expected) {
	}
}
?>
===DONE===
--EXPECT--
### short arguments
### arg1
### arg2
### arg3
### arg4
### arg5
### arg6
### arg9
### exceeding
===DONE===
