--TEST--
Senna_Snippet::createQuerySnippet() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testCreateQuerySnippet_WithValidArguments();
testCreateQuerySnippet_CreatesFromQueryString();

testCreateQuerySnippet_WithTagsByValue();
testCreateQuerySnippet_ConvertsTagsToString();

// ưάͤꤷƥ󥹥󥹲Ǥ뤳Ȥǧ롣
function testCreateQuerySnippet_WithValidArguments() {
	// query_string
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_NONE, 0, 100);
	} catch (Exception $unexpected) {
		echo "query_string: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// max_expressions
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_NONE, 0, 100);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_NONE, 0, 100);
	} catch (Exception $unexpected) {
		echo "max_expressions: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

	// encoding
	try {
		foreach (array(Senna::ENC_DEFAULT, Senna::ENC_NONE, Senna::ENC_EUC_JP, Senna::ENC_UTF8, Senna::ENC_SJIS) as $enc) {
			$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, $enc, 0, 100);
		}
	} catch (Exception $unexpected) {
		echo "encoding: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// flags
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, NULL, 100);
	} catch (Exception $unexpected) {
		echo "flags: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// width
	try {
		// Ĺwidth
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE,
				1024);
		// γƥɤФwidthû
		$snip = Senna_Snippet::createQuerySnippet('test sennaeternalforceblizzard', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE,
				4);
	} catch (Exception $unexpected) {
		echo "width: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// max_results
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100,
				1);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100,
				Senna_Snippet::MAX_RESULT_COUNT);
	} catch (Exception $unexpected) {
		echo "max_results: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// tag: string
	echo "### string\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'<b>', '</b>');
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'<strong>', '</strong>');
		// ⤷ξʸǤɤ
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'', '');
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'<open />', '');
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'', '<close />');
		
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				NULL, NULL);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				'<open />', NULL);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				NULL, '<close />');
	} catch (Exception $unexpected) {
		echo "string tag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// tag: array of string
	echo "### array\n";
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				array('<b>'), array('</b>'));
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				array('<b>', '<strong>'), array('</b>', '</strong>'));
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				array('<open />', ''), array('', '<close />'));
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				array('', ''), array('', ''));
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1,
				array(NULL, ''), array('', NULL));
	} catch (Exception $unexpected) {
		echo "array of tag: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

	// mapping
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>',
				NULL);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>',
				Senna_Snippet::MAPPING_NONE);
		$snip = Senna_Snippet::createQuerySnippet('test', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_DEFAULT, Senna_Snippet::NORMALIZE, 100, 1, '<strong>', '</strong>',
				Senna_Snippet::MAPPING_COMPAT);
	} catch (Exception $unexpected) {
		echo "mapping: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}

}

// +פORס-פʤɤα黻ҤSnippet뤳ȤǤ
function testCreateQuerySnippet_CreatesFromQueryString() {
	echo "### from query string\n";
	// Ƭ֤˻ȤΥɤФ­ʤʤäޤƬǤ
	$snip = Senna_Snippet::createQuerySnippet('am test senna fight', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_EUC_JP, 0, 35, 1,
			array('<b>', '<strong>', NULL), array('</b>', '</strong>', NULL));
	$resultList = $snip->execute('I am a test document. senna fight');
	if (count($resultList) === 1) {
		echo $resultList[0], "\n";
	}

	// ĹwidthʾΥɤ̵뤹(width=35ξΥƥ)
	$snip = Senna_Snippet::createQuerySnippet('+am OR senna -document___________adfafafasdfadsf_________ test fight', Senna_Snippet::DEFAULT_MAX_N_EXPRS, Senna::ENC_EUC_JP, 0,
			35, 1, array('<b>', '<strong>'), array('</b>', '</strong>'));
	$resultList = $snip->execute('I am a test. senna fight');
	if (count($resultList) === 1) {
		echo $resultList[0], "\n";
	}
}

// ʸconvert_to_array_ex()ƤǤ뤬ƤӽФ¦ѿȤѹ줿ꤷʤ
function testCreateQuerySnippet_WithTagsByValue() {
	echo "### tags by value\n";
	$a = '<b>';
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, 1, $a, '</b>');
	} catch (Exception $unexpected) {
		echo "by value1: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	var_dump($a);

	$b = '<b>';
	try {
		// ϤƤ⡢ͤѹʤ
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, 1, &$b, '</b>');
	} catch (Exception $unexpected) {
		echo "by value2: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
	var_dump($b);
}

// ϥĤ˻ꤷͤϡʸѴƻѤ
function testCreateQuerySnippet_ConvertsTagsToString() {
	echo "### converts tags to string\n";
	
	class ConvertToString {
		function __toString() {
			return "convert_to_string";
		}
	}
	
	// ʸǤϤʤͤȤ߹碌å
	foreach (array(1, -100, new ConvertToString(), NULL) as $openTag) {
		foreach (array(1, -100, new ConvertToString(), NULL) as $closeTag) {
			try {
				$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, 1, $openTag, $closeTag);
			} catch (Exception $unexpected) {
				echo "scalar: unexpected exception has been thrown.\n";
				echo $unexpected->getMessage(), "\n";
			}
		}
	}
	
	// ʸǤϤʤͤǥå
	$item = array(1, -100, new ConvertToString(), NULL);
	try {
		$snip = Senna_Snippet::createQuerySnippet('test', 1, Senna::ENC_DEFAULT, 0, 100, 1, $item, $item);
	} catch (Exception $expected) {
		echo "array: unexpected exception has been thrown.\n";
		echo $unexpected->getMessage(), "\n";
	}
}
?>
===DONE===
--EXPECT--
### string
### array
### from query string
I <b>am</b> a <strong>test</strong> document. senna <b>fight</b>
I <b>am</b> a <b>test</b>. <strong>senna</strong> <strong>fight</strong>
### tags by value
string(3) "<b>"
string(3) "<b>"
### converts tags to string
===DONE===