--TEST--
Senna_Snippet::execute() - success test
--SKIPIF--
<?php extension_loaded("senna") or die("skip"); ?>
--FILE--
<?php
testExecute_ReturnsNonEmptyArray();
testExecute_ReturnsEmptyArray();

function testExecute_ReturnsNonEmptyArray() {
	echo "### returns non-empty array\n";
	$width = 10; /* bytes */
	$max_results = 2;
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, $width, $max_results, '<b>', '</b>');
	$snip->addKeyword('test');
	$snip->addKeyword('execute()');
	$snip->addKeyword('snippet');
	$snip->addKeyword('tags');
	
	// ĹwidthХ(ϴޤʤ)Snippetmax_resultsĴޤ֤
	try {
		$resultList = $snip->execute('This is a test. Senna_Snippet::execute() returns an array of snippets of up to $width bytes not include tags.');
		
		// ͤǤ
		if (! is_array($resultList)) {
			echo "1: execute() returned a non-array variable in ", __FUNCTION__, "()\n";
		}
		
		// ͤǿϡ$max_resultsİǤ
		if ($max_results < count($resultList)) {
			echo "1: execute() returned an array which has over $max_results elements in ", __FUNCTION__, "()\n";
		}
		
		// ͤγǤϡ$widthХȰʸǤ
		foreach ($resultList as $snippet) {
			if (! is_string($snippet)) {
				echo "1: the returned array has a non-string element in ", __FUNCTION__, "()\n";
			}
			if ($width < strlen(strip_tags($snippet))) {
				echo "1: the element has over $width byte strlen() in ", __FUNCTION__, "()\n";
			}
		}
	} catch (Exception $unexpected) {
		echo "1: unexpected exception has been thrown in ", __FUNCTION__, "()\n";
		echo $unexpected->getMessage(), "\n";
	}

	// ʸ
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, $width, $max_results, '<b>', '</b>');
	$snip->addKeyword('ƥ');
	$snip->addKeyword('execute()');
	$snip->addKeyword('snippet');
	$snip->addKeyword('');
	try {
		$resultList = $snip->execute('ϥƥȤǤSenna_Snippet::execute()ϡ$widthХ(ĹϷ׻ʤ)˼ޤäsnippet֤ޤ');
		
		// ͤǤ
		if (! is_array($resultList)) {
			echo "1: execute() returned a non-array variable in ", __FUNCTION__, "()\n";
		}
		
		// ͤǿϡ$max_resultsİǤ
		if ($max_results < count($resultList)) {
			echo "1: execute() returned an array which has over $max_results elements in ", __FUNCTION__, "()\n";
		}
		
		// ͤγǤϡ$widthХȰʸǤ
		foreach ($resultList as $snippet) {
			if (! is_string($snippet)) {
				echo "1: the returned array has a non-string element in ", __FUNCTION__, "()\n";
			}
			if ($width < strlen(strip_tags($snippet))) {
				echo "1: the element has over $width byte strlen() in ", __FUNCTION__, "()\n";
			}
		}
	} catch (Exception $unexpected) {
		echo "1: unexpected exception has been thrown in ", __FUNCTION__, "()\n";
		echo $unexpected->getMessage(), "\n";
	}
}

// ɤʤж֤
function testExecute_ReturnsEmptyArray() {
	echo "### returns empty array\n";
	$snip = new Senna_Snippet(Senna::ENC_EUC_JP, Senna_Snippet::NORMALIZE, 100, 1, '<b>', '</b>');
	
	// ɤ1ĤaddKeyword()Ƥʤ
	try {
		$resultList = $snip->execute('This is a test.');
		if (! is_array($resultList)) {
			echo "1: execute() returned non-array variable in ", __FUNCTION__, "()\n";
		}
		if (0 != count($resultList)) {
			echo "1: execute() returned non-empty array in ", __FUNCTION__, "()\n";
		}
	} catch (Exception $unexpected) {
		echo "1: unexpected exception has been thrown in ", __FUNCTION__, "()\n";
		echo $unexpected->getMessage(), "\n";
	}
	
	// snippetоݤʸ˥ɤ1ĤޤޤƤʤä
	$snip->addKeyword('non-existent');
	try {
		$resultList = $snip->execute('This is a test.');
		if (! is_array($resultList)) {
			echo "2: execute() returned non-array variable in ", __FUNCTION__, "()\n";
		}
		if (0 != count($resultList)) {
			echo "2: execute() returned non-empty array in ", __FUNCTION__, "()\n";
		}
	} catch (Exception $unexpected) {
		echo "2: unexpected exception has been thrown in ", __FUNCTION__, "()\n";
		echo $unexpected->getMessage(), "\n";
	}
}
?>
===DONE===
--EXPECT--
### returns non-empty array
### returns empty array
===DONE===